﻿* Encoding: UTF-8.
*Various proximities
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_EDPROXMX*/vers2***************************************************************************.
define !KO_edproxmx(matrix= !charend('/') /seq= !charend('/') /oper= !charend('/') /numvars= !charend('/') /strvars= !charend('/')
                   /dgelem= !charend('/') /savedg= !charend('/') /savetr= !charend('/') /plot= !charend('/'))
!if (!oper=!null) !then !let !oper_= 'NONE' !else !let !oper_= !head(!oper) !ifend
!if ((!oper_='DIAG' !or !oper_='UADD' !or !oper_='LADD' !or !oper_='UMULT' !or !oper_='LMULT' !or !oper_='UEXP' !or !oper_='LEXP')
      !and !tail(!oper)=!null) !then
- echo ''.
- echo '>ERROR. Incorrectly specified OPER.'.
- echo '>!KO_EDPROXMX is not executed.'.
!else
 !if (!plot<>'NONE' !and !plot<>!null) !then !let !newdset= 'edproxmx.#$'
- dataset decl heatmap.#$ window= hidden.
- dataset decl edproxmx.#$.
 !else !let !newdset= '*'
 !ifend
-set mxloops 1E6.
-matrix.
-print /title '**** EDITING OF A PROXIMITY MATRIX ****'.
 !let !matr= !matrix !let !fcrop= 0 !let !lcrop= 0
 !if (!substr(!matr,1,1)='?') !then !let !matr= !substr(!matr,2) !let !fcrop= 1 !ifend
 !let !lm= !len(!matr)
 !if (!substr(!matr,!lm,1)='?') !then !let !matr= !substr(!conc(' ',!matr),1,!lm) !let !lcrop= 1 !ifend
-comp ok= 1.
-get m /vari= !matr /names= cnam.
 !if (!fcrop) !then
- comp m= m(:,2:ncol(m)).
- comp cnam= cnam(:,2:ncol(cnam)). 
 !ifend
 !if (!lcrop) !then
- comp m= m(:,1:(ncol(m)-1)).
- comp cnam= cnam(:,1:(ncol(cnam)-1)).
 !ifend
-get rnam /var= varname_.
-comp rnam= t(rnam).
 !if (!seq=!null) !then !let !seq_= 'COL' !else !let !seq_= !head(!seq) !ifend
 !if (!seq<>'ROW') !then
  !let !seq1= 'cnam' !let !seq2= 'rnam' !let !rind= 'ind2' !let !cind= 'ind1'
 !else
  !let !seq1= 'rnam' !let !seq2= 'cnam' !let !rind= 'ind1' !let !cind= 'ind2'
 !ifend
-do if nrow(m)<>ncol(m).
- comp cmp= 1.
-else if any(rnam<>cnam).
- comp cmp= 1.
-else.
- comp cmp= 0.
-print /title 'The input matrix is found square and with co-ordered rows with columns.'.
-print ncol(m) /title 'Size of the input matrix body:' /space= 0.
-end if.
-do if cmp.
  !if (!head(!seq)='IND') !then
- print /title '>ERROR. SEQ=IND demands the input matrix to be square and co-ordered.'.
-  comp ok= 0.
  !ifend
- do if ok.
-  comp flag= kroneker(t(!seq1),make(1,ncol(!seq2),1))=kroneker(!seq2,make(ncol(!seq1),1,1)).
-  comp ind2= rmax((flag=1)&*(1:ncol(flag))(make(1,nrow(flag),1),:)).
-  release flag.
-  comp nnz= msum(ind2>0).
-  do if nnz<2.
-   print /title '>ERROR. Among input matrix column names and row names there are too few'.
-   print /title '>identical to be able to compile a matrix.' /space= 0.
-   comp ok= 0.
-  else.
-   comp ind1= make(1,nnz,0).
-   comp cnt= 0.
-   loop i= 1 to nrow(ind2).
-    do if ind2(i).
-     comp cnt= cnt+1.
-     comp ind1(cnt)= i.
-    end if.
-   end loop.
-   comp ind2= ind2(ind1).
-   comp m= m(!rind,!cind).
-   comp cnam= cnam(!cind).
-  end if.
- end if.
-end if.
-release rnam.
-do if ok.
  !if (!oper_='UADD' !or !oper_='LADD') !then !let !opr= '+' !else !let !opr= '*' !ifend
  !if (!oper='AVER' !or !oper='GMEAN' !or !oper='HMEAN' !or !oper='UBYL' !or !oper='LBYU' !or !oper='SWITHG' !or !oper='GWITHS' !or !oper='ABS') !then
-  comp dg= diag(m).
   !if (!oper='AVER') !then
-   comp m= (m+t(m))/2.
   !else !if (!oper='GMEAN') !then
-   do if any(m<0).
-    print /title '>ERROR. OPER=GMEAN, but the matrix has negative values.'.
-    comp ok= 0.
-   else.
-    comp m= sqrt(m&*t(m)).
-   end if.
   !else !if (!oper='HMEAN') !then
-   do if any(m<0).
-    print /title '>ERROR. OPER=HMEAN, but the matrix has negative values.'.
-    comp ok= 0.
-   else.
-    comp tm= t(m).
-    comp m= m&*tm*2/(m+tm+(tm=0)).
-    release tm.
-   end if.
   !else !if (!oper='UBYL' !or !oper='LBYU') !then
    !if (!oper='LBYU') !then
-    comp m= t(m).
-   !ifend
-   loop i= 1 to ncol(m).
-    comp m(i,:)= t(m(:,i)).
-   end loop.
   !else !if (!oper='SWITHG' !or !oper='GWITHS') !then
-   comp tm= t(m).
    !if (!oper='SWITHG') !then
-    comp gv= m&*(m>tm).
    !else
-    comp gv= m&*(m<tm).
    !ifend
-   comp ev= m&*(m=tm).
-   comp m= gv+t(gv)+ev.
-   release tm,gv,ev.
   !else !if (!oper='ABS') !then
-   comp m= abs(m).
   !ifend !ifend !ifend !ifend !ifend !ifend
-  call setdiag(m,dg).
  !else !if (!oper='URANK' !or !oper='LRANK' !or !oper='RANK') !then
-  comp @n= ncol(m).
-  comp m= reshape(m,@n**2,1).
-  comp @uind= make(1,@n*(@n-1)/2,0).
-  comp @lind= make(1,@n*(@n-1)/2,0).
-  loop @i= 1 to @n-1.
-   comp @st= -(@n-1)+(@n+.5)*@i-.5*@i**2.
-   comp @ind= @i*@n+(1-@n+@i):0.
-   comp @uind(@st:(@st+ncol(@ind)-1))= @ind.
-   comp @ind= @i*(@n+1)+0:(@n*(@n-1-@i)):@n.
-   comp @lind(@st:(@st+ncol(@ind)-1))= @ind.
-  end loop.
   !if (!oper='LRANK') !then
-   comp m(@lind)= rnkorder(m(@lind)).
   !else !if (!oper='URANK') !then
-   comp m(@uind)= rnkorder(m(@uind)).
   !else
-   comp m({@lind,@uind})= rnkorder(m({@lind,@uind})).
   !ifend !ifend
-  release @uind,@lind.
-  comp m= reshape(m,@n,@n).
  !else !if (!oper='FLIP') !then
-   comp m= t(m).
  !else !if (!oper_='UADD' !or !oper_='UMULT' !or !oper_='LADD' !or !oper_='LMULT') !then
-  loop i= 1 to ncol(m)-1.
-   comp ind= (i+1):ncol(m).
    !if (!oper_='UADD') !then
-    comp m(i,ind)= m(i,ind) !opr !tail(!oper).
    !else
-    comp m(ind,i)= m(ind,i) !opr !tail(!oper).
    !ifend
-  end loop.
  !else !if (!oper_='UEXP' !or !oper_='LEXP') !then !let !power= !tail(!oper)
-  do if !power=0.
-   print /title '>ERROR. Exponent at OPER=UEXP/LEXP is zero.'.
-   comp ok= 0.
-  else.
-   loop i= 1 to ncol(m)-1.
-    comp ind= (i+1):ncol(m).
-    comp mi= !if (!oper_='UEXP') !then m(i,ind) !else m(ind,i) !ifend.
-    do if !power<>rnd(!power).
-     do if any(mi<0).
-      print /title '>ERROR. Exponent at OPER=UEXP/LEXP is specified fractional, but in'.
-      print /title '>the matrix triangle there are negative values.' /space= 0.
-      comp ok= 0.
-      break.
-     end if.
-    end if.
-    do if !power<0.
-     do if any(mi=0).
-      print /title '>ERROR. Exponent at OPER=UEXP/LEXP is specified negative, but in'.
-      print /title '>the matrix triangle there are zero values.' /space= 0.
-      comp ok= 0.
-      break.
-     end if.
-    end if.
-    comp !if (!oper_='UEXP') !then m(i,ind) !else m(ind,i) !ifend= mi&**!power.
-   end loop.
-  end if.
  !else !if (!oper_='DIAG') !then !let !dg= !substr(!tail(!oper),2) !let !dgvar= 0
   !do !i= 1 !to !len(!dg)
    !if (!index('-.0123456789',!substr(!dg,!i,1))=0) !then !let !dgvar= 1 !break !ifend
   !doend
   !if (!dgvar) !then
-   get dg /var= !dg.
-   do if cmp.
-    comp dg= dg(!rind).
-   end if.
-   call setdiag(m,dg).
   !else
-   call setdiag(m,!dg).
   !ifend
  !ifend !ifend !ifend !ifend !ifend !ifend
-end if.
-do if ok.
- comp cmp2= 0.
- comp cmp3= 0.
  !if (!seq='GRAD1' !or !seq='GRAD2') !then
   !if (!dgelem='NO') !then
-   comp dg= diag(m).
-   call setdiag(m,0).
   !ifend
-  comp grad= make(1,ncol(m),0).
-  loop i= 1 to ncol(m).
    !if (!seq='GRAD1') !then
-    comp grad(i)= m(i,:)*m(:,i).
    !else
-    comp grad(i)= rsum(m(i,:))+csum(m(:,i)).
    !ifend
-  end loop.
-  comp grad= grade(-grad).
-  comp m(grad,grad)= m.
-  comp cnam(grad)= cnam.
   !if (!dgelem='NO') !then
-   comp dg(grad)= dg.
-   call setdiag(m,dg).
   !ifend
-  comp cmp2= 1.
  !else !if (!head(!seq)='IND') !then
-  get ind /file= !tail(!seq).
-  do if any(trunc(ind)<=0) or any(trunc(ind)>ncol(m)).
-   print /title ">ERROR. The vector of indices taken from 'file' at SEQ=IND contains indices".
-   print /title '>which are nonpositive or exceed the size of the input matrix.' /space= 0.
-   comp ok= 0.
-  else.
-   comp m= m(ind,ind).
-   comp cnam= cnam(ind).
-   comp cmp3= 1.
-  end if.
  !ifend !ifend
-end if.
-do if ok.
  !if (!numvars<>!null) !then !let !natt= 'natt,' !let !nattnam= 'nattnam,'
-  get natt /vari= !numvars /miss= accept /sysmis= -999 /names= nattnam.
-  do if cmp.
-   comp natt= natt(!rind,:).
-  end if.
-  do if cmp2.
-   comp natt(grad,:)= natt.
-  else if cmp3.
-   comp natt= natt(ind,:).
-  end if.
  !ifend
  !if (!strvars<>!null) !then !let !satt= 'satt,' !let !sattnam= 'sattnam,'
-  get satt /vari= !strvars /miss= accept /names= sattnam.
-  do if cmp.
-   comp satt= satt(!rind,:).
-  end if.
-  do if cmp2.
-   comp satt(grad,:)= satt.
-  else if cmp3.
-   comp satt= satt(ind,:).
-  end if.
  !ifend
  !if (!savedg<>!null) !then
-  save {t(cnam),diag(m)} /out= !savedg /vari= varname_ diag /string= varname_.
  !ifend
  !if (!savetr<>!null) !then
-  comp @n= ncol(m).
-  comp @n1= @n+1.
-  comp @1n= 1-@n.
-  comp @nn1= @n*(@n-1).
-  comp m_= reshape(m,@n**2,1).
-  comp @uind= make(1,@nn1/2,0).
-  comp @lind= make(1,@nn1/2,0).
-  comp @ind1= make(1,@nn1/2,0).
-  comp @ind2= make(1,@nn1/2,0).
-  loop @i= 1 to @n-1.
-   comp @st= @1n+@i*(@n-@i/2+.5).
-   comp @ind= (@i*@n1+@1n):(@i*@n).
-   comp @pos= @st:(@st+ncol(@ind)-1).
-   comp @uind(@pos)= @ind.
-   comp @ind= (@i*@n1):(@i+@nn1):@n.
-   comp @lind(@pos)= @ind.
-   comp @ind1(@pos)= make(1,ncol(@ind),@i).
-   comp @ind2(@pos)= (@i+1):@n.
-  end loop.
-  save {m_(@lind),m_(@uind),t({@ind1;@ind2}),t({cnam(@ind1);cnam(@ind2)})} /out= !savetr
       /vari= lower upper colrow elem varname1 varname2 /string= varname1 varname2.
-  release m_,@lind,@uind.
  !ifend
- do if cmp or cmp2 or cmp3.

-  print /title 'Of the input matrix, there was made square matrix with composition/order'.
-  print /title !quote(!conc('of rows/columns set by s/c SEQ=',!seq_,'.')) /space= 0.
   !if ((!seq='GRAD1' !or !seq='GRAD2' !or !seq_='IND') !and !oper_<>'NONE') !then
-   print /title !quote(!conc('Reordering SEQ=',!seq_,' was made after operation OPER=',!oper_,'.')) /space= 0.
   !ifend

-  print ncol(m) /title 'Size of the body of the output matrix:' /space= 0.
- else.
   !if (!oper_='NONE') !then
-   print /title 'And, because OPER=NONE, the output matrix is identical with the input one.' /space= 0.
   !ifend
- end if.
  !if (!oper_<>'NONE') !then
-  print /title !quote(!conc('Carried out was requested operation in the matrix body: OPER=',!oper,'.')).
  !ifend
  !if (!plot<>'NONE' !and !plot<>!null) !then
-  save {{kroneker(t(cnam),make(ncol(cnam),1,1)),kroneker(make(ncol(cnam),1,1),t(cnam))},
        reshape(m,ncol(m)**2,1)} /out= heatmap.#$ /vari= row col val /string= row col.
  !ifend
  !if (!seq_='IND') !then
-  do if any(grade(ind)<>rnkorder(ind)).
-   comp names= {!nattnam !sattnam 'varname_'}.
-   print /title '>WARNING. In vector IND, repeating indices are present. In this condition,'.
-   print /title '>since saving variables with same names is illegal, column names of' /space= 0.
-   print /title '>the output matrix are given as COLn.' /space= 0.
-  else.
-   comp names= {!nattnam !sattnam 'varname_',cnam}.
-  end if.
  !else
-  comp names= {!nattnam !sattnam 'varname_',cnam}.
  !ifend
- save {!natt !satt t(cnam),m} /out= !newdset /names= names /string= varname_ !strvars.
-else.
- print /title '>!KO_EDPROXMX is executed incorrectly.' /space= 0.
- save 0 /out= *.
-end if.
-end matrix.
 !if (!numvars<>!null) !then
- recode !numvars (-999=sysmis).
- exec.
 !ifend
 !if (!plot<>'NONE' !and !plot<>!null) !then
  !if (!plot='GREY' !or !plot='RGREY') !then
   !let !element= 'ELEMENT: polygon(position(col*row)),color(color.grey),color.brightness.exterior(val),color.brightness.interior(val))'
  !else
   !let !element= 'ELEMENT: polygon(position(col*row)),color.exterior(val),color.interior(val))'
  !ifend
- dataset activ heatmap.#$.
- var lev val (sca).
- do if $casenum=1.
-  write outfile= 'temp_KO_edproxmx.sps'
      /'PAGE: begin(scale(800px,620px))'
      /'SOURCE: s=userSource(id("graphdataset"))'
      /'DATA: row=col(source(s),name("row"),unit.category())'
      /'DATA: col=col(source(s),name("col"),unit.category())'
      /'DATA: val=col(source(s),name("val"))'
      /'GUIDE: axis(dim(1),label(" "),gridlines())'
      /'GUIDE: axis(dim(2),label(" "),gridlines())'
      /'GUIDE: legend(aesthetic(aesthetic.color.brightness.exterior),null())'
      /'SCALE: cat(dim(1),sort.data())'
      /'SCALE: cat(dim(2),sort.data(),reverse())'
     !if (!plot='RGREY') !then
      /'SCALE: linear(aesthetic(aesthetic.color.brightness.interior),reverse())'
      /'SCALE: linear(aesthetic(aesthetic.color.brightness.exterior),reverse())'
     !ifend
      /!quote(!element)
      /'PAGE: end()'.
- end if.
- GGRAPH /GRAPHDATASET NAME= "graphdataset" VARIABLES= col row val
        /GRAPHSPEC SOURCE= GPLFILE('temp_KO_edproxmx.sps').
- dataset close heatmap.#$.
- dataset activ edproxmx.#$.
- dataset close *.
- erase file 'temp_KO_edproxmx.sps'.
 !ifend
!ifend
!enddefine.

*/*!KO_GOWER*/vers5***************************************************************************.
define !KO_gower(sca= !charend('/') /ord= !charend('/') /bin= !charend('/') /nom= !charend('/') /cnt= !charend('/') /weights= !charend('/')
             /missing= !charend('/') /id= !charend('/') /flatten= !charend('/') /add05= !charend('/') /reverse= !charend('/') /ecorrect= !charend('/'))
!let !ok= 1
!let !flttn= !conc(' ',!flatten,' ') !let !dd05= !conc(' ',!add05,' ')
!let !miss= !head(!missing) !let !miss2= !head(!tail(!missing))
!if (!miss=!null) !then !let !miss= 'LISTWISE' !ifend
!if (!miss<>'LISTWISE' !and !miss<>'PAIRWISE' !or !miss2<>'ASVALID' !and !miss2<>!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. MISSING specified incorrectly. !KO_GOWER is executed incorrectly.'.
-new file.
!ifend
!if (!weights<>!null) !then !let !wei= !weights
 !do !w !in (!conc(!sca,' ',!ord,' ',!bin,' ',!nom,' ',!cnt))
  !if (!wei=!null) !then !let !wei= 0 !break !ifend
  !let !wei= !tail(!wei)
 !doend
 !if (!wei<>!null) !then !let !ok= 0
- echo ' '.
- echo '>ERROR. Number of WEIGHTS <> number of input variables. !KO_GOWER is executed incorrectly.'.
- exec.
- new file.
 !else !let !wei= !weights
 !ifend
!else !let !wei= !null
 !do !w !in (!conc(!sca,' ',!ord,' ',!bin,' ',!nom,' ',!cnt)) !let !wei= !conc(!wei,' ',1) !doend
!ifend
!if (!ok) !then
-set errors none.
-temp.
-comp caseno#$= $casenum.
 !if (!id=!null) !then !let !idd= 'strid#$' !let !iddd= 'id'
- string strid#$ (a8).
- comp strid#$= concat('C',ltrim(string(caseno#$,f8))).
 !else !let !idd= !id !let !iddd= !id
 !ifend
 !if (!miss2='ASVALID') !then
- miss val !sca !ord !bin !nom ().
 !ifend
 !if (!miss='LISTWISE') !then
- count #miss= !sca !ord !bin !nom (missing).
- select if #miss=0.
 !ifend
-set mxloops 1E6 errors list.
-matrix.
-comp let= 1.
-get ids /vari= !idd caseno#$.
-do if nrow(ids)=1.
- comp let= 0.
- print /title '>ERROR. Insufficient cases. Matrix of coef-s will not be created.'.
- print /title '>!KO_GOWER is executed incorrectly.' /space= 0.
-else.
- comp cums= make(nrow(ids),nrow(ids),0).
- comp cumw= make(nrow(ids),nrow(ids),0).
- comp ones= make(1,nrow(ids),1).
  !do !i !in (!sca)
   !let !vw= !head(!wei) !let !wei= !tail(!wei)
-  get v /var= !i /miss= omit.
   !if (!index(!flttn,!conc(' ',!i,' '))>0) !then
-   comp n= nrow(v).
-   comp sum= csum(v).
-   comp sd= sqrt((cssq(v)-sum&*sum/n)/n).
-   comp max= (cmax(v)-sum/n)/sd.
-   comp min= (cmin(v)-sum/n)/sd.
-   comp range= ln(max+sqrt(max*max+1))-ln(min+sqrt(min*min+1)).
   !else
-   comp range= cmax(v)-cmin(v).
   !ifend
-  get v /var= !i /miss= -999.
-  comp w= sscp(t(v<>-999))*!vw.
   !if (!index(!flttn,!conc(' ',!i,' '))>0) !then
-   comp v= (v-sum/n)/sd.
-   comp v= ln(v+sqrt(v&*v+1)).
   !ifend
-  comp v= v*ones.
-  comp v= 1-abs(v-t(v))/(range+(range=0)).
-  comp cums= cums+v&*w.
-  comp cumw= cumw+w.
  !doend
  !do !i !in (!ord)
   !let !vw= !head(!wei) !let !wei= !tail(!wei)
-  get v /var= !i /miss= omit.
-  comp v= rnkorder(v).
-  comp r_min= cmin(v).
-  comp r_max= cmax(v).
-  comp t_min= (csum(v=r_min)-1)/2.
-  comp t_max= (csum(v=r_max)-1)/2.
-  get v /var= !i /miss= -999.
-  comp w= sscp(t(v<>-999))*!vw.
-  comp v= v+abs(cmin(v))*(v<>-999).
-  comp v= rnkorder(v).
-  comp v= v*ones.
-  comp vtv= v=t(v).
-  comp t_i= (rsum(vtv)-1)/2.
-  comp t_i= t_i*ones.
-  do if r_max=r_min.
-   comp v= vtv.
-  else.
-   comp v= vtv+(not vtv)&*(1-(abs(v-t(v))-t_i-t(t_i))/(r_max-r_min-t_max-t_min)).
-  end if.
-  comp cums= cums+v&*w.
-  comp cumw= cumw+w.
-  release vtv.
  !doend
  !do !i !in (!bin)
   !let !vw= !head(!wei) !let !wei= !tail(!wei)
-  get v /var= !i /miss= omit.
-  do if not all((v=1)+(v=0)).
-   comp let= 0.
-   print /title '>ERROR. Non-binary (not 0 or 1) variable encountered among BIN.'.
-   print /title '>!KO_GOWER is executed incorrectly.' /space= 0.
-  end if.
-  get v /var= !i /miss= -999.
-  comp w= sscp(t(v<>-999))*!vw.
-  comp v= v*ones.
-  comp w= w&*((v+t(v))>0).
-  comp v= v&*t(v).
-  comp cums= cums+v&*w.
-  comp cumw= cumw+w.
  !doend
  !do !i !in (!nom)
   !let !vw= !head(!wei) !let !wei= !tail(!wei)
-  get v /var= !i /miss= -999.
-  comp w= sscp(t(v<>-999))*!vw.
-  comp v= v*ones.
-  comp v= (v=t(v)).
-  comp cums= cums+v&*w.
-  comp cumw= cumw+w.
  !doend
  !do !i !in (!cnt)
   !let !vw= !head(!wei) !let !wei= !tail(!wei)
-  get v /var= !i /miss= -999.
-  comp w= sscp(t(v<>-999))*!vw.
   !if (!index(!dd05,!conc(' ',!i,' '))>0) !then
-   comp v= v+.5.
   !else !let !zdenom= '+(vptv=0)'
   !ifend
-  comp v= v*ones.
-  comp tv= t(v).
-  comp vptv= abs(v+tv).
-  comp v= 1-sqrt(abs(v-tv)/(vptv !zdenom)).
-  comp cums= cums+v&*w.
-  comp cumw= cumw+w.
-  release tv,vptv.
  !doend
- release v,w.
-end if.
-do if let.
- comp z= cumw=0.
- do if any(z).
-  comp sumz= rsum(z).
-  comp veci= 0.
-  comp nums= t(1:nrow(cumw)).
-  comp max= cmax(sumz).
-  loop if max>0.
-   comp i= cmax((sumz=max)&*nums).
-   comp sumz= sumz-z(:,i).
-   comp sumz(i)= 0.
-   comp max= cmax(sumz).
-   comp veci= {veci,i}.
-  end loop.
-  do if ncol(veci)<nrow(cumw).
-   comp veci2= 0.
-   loop i= 1 to nrow(cumw).
-    do if not any(i=veci).
-     comp veci2= {veci2,i}.
-    end if.
-   end loop.
-   comp veci2= veci2(2:ncol(veci2)).
-   comp cumw= cumw(veci2,veci2).
-   comp cums= cums(veci2,veci2). 
-   comp ids= ids(veci2,:).
-   print (ncol(veci)-1) /title '>WARNING. This number of cases have many noncomputable coef-s:'.
-   print /title '>These cases were internally deleted. !KO_GOWER will proceed.' /space= 0.
-  else.
-   comp let= 0.
-   print /title '>ERROR. Too many noncomputable coef-s. Matrix of coef-s will not be created.'.
-   print /title '>!KO_GOWER is executed incorrectly.' /space= 0.
-  end if.
- end if.
- release z.
-end if.
-do if let.
- comp cums= cums/cumw.
  !if (!reverse<>'NONE' !and !reverse<>!null) !then
   !if (!reverse='ARCCOS') !then
-   comp cums= 3.14159265358979/2-arsin(cums).
   !else !if (!reverse='RONEMINUS') !then
-   comp cums= sqrt(1-cums).
   !else
-   comp cums= 1-cums.
   !ifend !ifend
   !if (!ecorrect<>'NONE' !and !ecorrect<>!null) !then
-   do if ncol(cums)=2.
-    print /title '>WARNING. Subcommand ECORRECT will be ignored because the matrix is only 2x2.'.
-   else.
-    comp dc= cums&*cums.
-    comp rmean= (rsum(dc)/ncol(dc))*make(1,ncol(dc),1).
-    comp dc= (rmean+t(rmean)-dc-msum(dc)/ncol(dc)**2)/2.
-    release rmean.
-    comp ev= eval(dc).
-    print ev((nrow(ev)-2):nrow(ev)) /title 'EUCLIDITY CHECK-UP. Three least eigenvalues of the double centration matrix:' /format= f16.9.
-    comp lstev= rnd(ev(nrow(ev))*1E10)/1E10.
-    do if lstev>=0.
-     print /title 'Subcommand ECORRECT: The distances are geometrically euclidean and need no correction.'.
-    else.
      !if (!ecorrect='LINGOES') !then
-      comp kcons= -2*lstev+1E-7.
-      print kcons /title 'ECORRECT=LINGOES added constant to squared distances:' /format= f16.9.
-      comp d_= sqrt(cums&*cums+kcons).
      !else
-      comp rmean= (rsum(cums)/ncol(cums))*make(1,ncol(cums),1).
-      comp dc1= (rmean+t(rmean)-cums-msum(cums)/ncol(cums)**2)/2.
-      release rmean.
-      comp dc1= {make(nrow(cums),nrow(cums),0),2*dc;-ident(nrow(cums)),-4*dc1}.
-      comp @n= ncol(dc1).
-      loop @i= 1 to @n-2.
-       comp @ind= (@i+1):@n.
-       comp @v= dc1(@ind,@i).
-       comp @v1= ((@v(1)<0)-(@v(1)>=0))*sqrt(mssq(@v)).
-       comp @u1= sqrt((@v1-@v(1))/(2*@v1+(@v1=0))).
-       comp @u= -@v/(2*@u1*@v1+(@v1=0)).
-       comp @u(1)= @u1.
-       comp @h= ident(nrow(@u))-2*sscp(t(@u)).
-       comp dc1(@ind,@i:@n)= @h*dc1(@ind,@i:@n).
-       comp dc1(:,@ind)= dc1(:,@ind)*@h.
-      end loop.
-      release @v,@v1,@u,@u1,@h.
-      comp @stv= make(1,@n,0).
-      comp @env= make(1,@n,0).
-      comp @stv(1)= 1.
-      comp @env(1)= @n.
-      comp @wr= 1.
-      loop @re= 1 to @n if @stv(@re).
-       comp @st= @stv(@re).
-       comp @en= @env(@re).
-       loop @m= 1 to @n if @st<@en.
-        do if @en-@st=1.
-         do if abs(dc1(@en,@st))<=1E-9*rmax(abs({dc1(@st,@st),dc1(@en,@en)})).
-          comp dc1(@en,@st)= 0.
-         else.
-          comp @l= dc1(@st,@st)+dc1(@en,@en).
-          comp @v= dc1(@st,@st)*dc1(@en,@en)-dc1(@st,@en)*dc1(@en,@st).
-          comp @v= @l**2-4*@v.
-          do if @v>=0.
-           comp @l= (@l+sqrt(@v))/2.
-           comp @v= make(2,1,1).
-           do if dc1(@st,@en)=0.
-            comp @v(1,1)= (@l-dc1(@en,@en))/dc1(@en,@st).
-           else.
-            comp @v(2,1)= (@l-dc1(@st,@st))/dc1(@st,@en).
-           end if.
-           comp @v= @v/sqrt(mssq(@v)).
-           comp @v= {@v,{-@v(2);@v(1)}}.
-           comp dc1(@st:@en,:)= t(@v)*dc1(@st:@en,:).
-           comp dc1(:,@st:@en)= dc1(:,@st:@en)*@v.
-          end if.
-         end if.
-         break.
-        else.
-         loop @it= 1 to 100.
-          comp @en1= @en-1.
-          comp @st1= @st+1.
-          loop @i= @st to @en-2.
-           comp @ind= @i:(@i+2).
-           do if @i=@st.
-            comp @k1= dc1(@en1,@en1)+dc1(@en,@en).
-            comp @k2= dc1(@en1,@en1)*dc1(@en,@en)-dc1(@en1,@en)*dc1(@en,@en1).
-            comp @v= {dc1(@st,@st)**2-dc1(@st,@st)*@k1+@k2+dc1(@st,@st1)*dc1(@st1,@st);dc1(@st1,@st)*(dc1(@st,@st)+dc1(@st1,@st1)-@k1);dc1(@st1,@st)*dc1(@st+2,@st1)}.
-           else.
-            comp @v= dc1(@ind,@i-1).
-           end if.
-           comp @s= ((@v(1)>=0)-(@v(1)<0))*sqrt(mssq(@v)).
-           do if @s<>0.
-            comp @v(1)= @v(1)+@s.
-            comp @v= @v*(t(@v)/(@v(1)*@s)).
-            comp @v= ident(3)-@v.
-            comp dc1(@ind,:)= @v*dc1(@ind,:).
-            comp dc1(:,@ind)= dc1(:,@ind)*@v.
-           end if.
-          end loop.
-          comp @b= dc1(@en,@en-2).
-          comp @r= dc1(@en1,@en-2).
-          comp @h= sqrt(@r**2+@b**2).
-          do if @h.
-           comp @c= abs(@r)/@h.
-           comp @s= ((@r>=0)-(@r<0))*@b/@h.
-           comp @v= {@c,-@s;@s,@c}.
-           comp dc1(@en1:@en,:)= t(@v)*dc1(@en1:@en,:).
-           comp dc1(:,@en1:@en)= dc1(:,@en1:@en)*@v.
-          end if.
-          comp @dg= abs(diag(dc1)).
-          comp @az= abs(diag(dc1(@st1:@en,@st:@en1)))<=1E-9*rmax({@dg(@st1:@en),@DG(@st:@en1)}).
-          do if any(@az).
-           comp @p= cmax(@az&*t(@st:@en1)).
-           comp dc1(@p+1,@p)= 0.
-           break.
-          end if.
-         end loop.
-         comp @wr= @wr+1.
-         comp @stv(@wr)= @st.
-         comp @env(@wr)= @p.
-         comp @st= @p+1.
-        end if.
-       end loop.
-      end loop.
-      comp kcons= cmax(diag(dc1))+1E-7.
-      release dc1,@stv,@env,@dg,@az.
-      print kcons /title 'ECORRECT=CAILLIEZ added constant to distances:' /format= f16.9.
-      comp d_= cums+kcons.
      !ifend
-     call setdiag(d_,0).
-     print (msum(d_-cums)/msum(cums)*100) /title 'which have led to the increase of distances magnitude in the matrix, in % of the initial, by:' /format= f8.4 /space= 0.
-     comp cums= d_.
-     release d_.
-     comp dc= cums&*cums.
-     comp rmean= (rsum(dc)/ncol(dc))*make(1,ncol(dc),1).
-     comp dc= (rmean+t(rmean)-dc-msum(dc)/ncol(dc)**2)/2.
-     comp ev= eval(dc).
-     print ev((nrow(ev)-2):nrow(ev)) /title 'Three least eigenvalues of the double centration matrix after the correction:' /format= f16.9.
-     release rmean,dc,ev.
-    end if.
-   end if.
   !ifend
  !ifend
- save {ids,cums} /out= * /vari= !iddd caseno_ var1 to var50000 /string= !iddd.
-else.
- save 0 /out= *.
-end if.
-end matrix.
-set results none.
-matrix.
-get cums /names= names.
-do if ncol(cums)>1.
- comp rowtype= make(nrow(cums),1,'PROX').
- comp cn= {'rowtype_',!quote(!iddd),'caseno_','varname_',names(3:ncol(names))}.
- save {rowtype,cums(:,1:2),t(names(3:ncol(names))),cums(:,3:ncol(cums))} /out= * /names= cn /strings= rowtype_ !iddd varname_.
-end if.
-end matrix.
-set results list.
 !if (!reverse='ONEMINUS') !then
- val lab rowtype_ 'PROX' 'DISSIMILARITY [ONEMINUS] GOWER'.
 !else !if (!reverse='RONEMINUS') !then
- val lab rowtype_ 'PROX' 'DISSIMILARITY [RONEMINUS] GOWER'.
 !else !if (!reverse='ARCCOS') !then
- val lab rowtype_ 'PROX' 'DISSIMILARITY [ARCCOS] GOWER'.
 !else
- val lab rowtype_ 'PROX' 'SIMILARITY GOWER'.
 !ifend !ifend !ifend
-format caseno_ (f8).
-var lev all (sca) rowtype_ to varname_ (nom).
!ifend
!enddefine.

*/*!KO_PROXQNT*/vers2***************************************************************************.
define !KO_proxqnt(vars= !charend('/') /view= !charend('/') /normalize= !charend('/') /measure= !charend('/') /abs= !charend('/') /noroot= !charend('/')
               /reverse= !charend('/') /missing= !charend('/') /id= !charend('/') /matrix= !charend('/'))
!if (!view='VARIABLE' !and !id<>!null) !then
-echo ''.
-echo '>ERROR. Specifying ID is incompatible with VIEW=VARIABLE. !KO_PROXQNT is executed incorrectly.'.
-new file.
!else
 !if (!noroot<>'YES') !then !let !sqrt= 'sqrt' !ifend
 !if (!view<>'VARIABLE') !then !let !caseno= 'caseno#$' !let !fcaseno= 'format caseno_ (f8)'
- set errors none.
- temp.
- comp caseno#$= $casenum.
  !if (!id=!null) !then !let !idd= 'strid#$' !let !iddd= 'id'
-  string strid#$ (a8).
-  comp strid#$= concat('C',ltrim(string(caseno#$,f8))).
  !else !let !idd= !id !let !iddd= !id
  !ifend
 !ifend
-set mxloops 100000 errors list.
-matrix.
-get data /vari= !idd !caseno !vars /names= names /miss= !if (!missing='INCLUDE') !then accept /sysmis= omit !else omit !ifend.
 !if (!view<>'VARIABLE') !then
- comp id= data(:,1).
- comp case= data(:,2).
- comp data= data(:,3:ncol(data)).
- comp names= names(3:ncol(names)).
- comp data= t(data).
 !ifend
-comp done= 0.
-do if ncol(data)=1.
- print /title '>ERROR. Number of items between which to compute proximity is less than 2.'.
 !if (!normalize='SUM') !then
- else if any(data<0).
-  print /title '>ERROR. NORMALIZE=SUM, but data have negative values.'.
 !else !if (!normalize='CLR') !then
- else if any(data<=0).
-  print /title '>ERROR. NORMALIZE=CLR, but data have nonpositive values.'.
 !ifend !ifend
-else.
  !if (!normalize='SUM') !then
-  comp sum= csum(data).
-  comp data= data/(sum+(sum=0))(make(1,nrow(data),1),:).
  !else !if (!normalize='SS') !then
-  comp ss= cssq(data).
-  comp data= data/(sqrt(ss)+(ss=0))(make(1,nrow(data),1),:).
  !else !if (!normalize='EXP') !then
-  comp epv= exp(data).
-  comp data= epv/csum(epv)(make(1,nrow(data),1),:).
  !else !if (!normalize='CLR') !then
-  comp data= data/csum(data)(make(1,nrow(data),1),:).
-  comp gmean= exp(csum(ln(data))/nrow(data)).
-  comp data= ln(data/gmean(make(1,nrow(data),1),:)).
  !else !if (!normalize='Z') !then
-  comp data= data-(csum(data)/nrow(data))(make(1,nrow(data),1),:).
-  comp sd= sqrt(cssq(data)/(nrow(data)-1)).
-  comp data= data/(sd+(sd=0))(make(1,nrow(data),1),:).
  !else !if (!normalize='ZDIM') !then
-  comp data= data-(rsum(data)/ncol(data))*make(1,ncol(data),1).
-  comp sd= sqrt(rssq(data)/ncol(data)).
-  comp data= data/((sd+(sd=0))*make(1,ncol(data),1)).
  !else !if (!normalize='RANGE') !then
-  comp range= cmax(data)-cmin(data).
-  comp data= data/(range+(range=0))(make(1,nrow(data),1),:).
  !else !if (!normalize='RESCALE') !then
-  comp min= cmin(data).
-  comp max= cmax(data).
-  comp data= data-(min-.5*(max=min))(make(1,nrow(data),1),:).
-  comp data= data/(max-min+(max=min))(make(1,nrow(data),1),:).
  !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend
  !let !symm= 1
- comp cumd= make(ncol(data),ncol(data),0).
- comp ones= make(ncol(data),1,1).
  !if (!head(!measure)='MINK') !then !let !power= !tail(!measure)
   !let !lab= !conc('DISSIMILARITY MINKOWSKI p=',!power)
-  loop i= 1 to nrow(data).
-   comp di= data(i,:)(ones,:).
-   comp cumd= cumd+abs(di-t(di))&**!power.
-  end loop.
   !if (!noroot<>'YES') !then
-   comp cumd= cumd&**(1/!power).
   !ifend
-  comp done= 1.
  !else !if (!measure='BLOCK') !then !let !lab= 'DISSIMILARITY BLOCK'
-  loop i= 1 to nrow(data).
-   comp di= data(i,:)(ones,:).
-   comp cumd= cumd+abs(di-t(di)).
-  end loop.
-  comp done= 1.
  !else !if (!measure='CHEB') !then !let !lab= 'DISSIMILARITY CHEB'
-  loop i= 1 to nrow(data).
-   comp di= data(i,:)(ones,:).
-   comp di= abs(di-t(di)).
-   comp cumd= (di>cumd)&*di+(di<=cumd)&*cumd.
-  end loop.
-  release di.
-  comp done= 1.
  !else !if (!measure='CANBERRA') !then !let !lab= 'DISSIMILARITY CANBERRA'
-  loop i= 1 to nrow(data).
-   comp di= data(i,:)(ones,:).
-   comp tdi= t(di).
-   comp diptdi= abs(di)+abs(tdi).
-   comp cumd= cumd+abs(di-tdi)/(diptdi+(diptdi=0)).
-  end loop.
-  comp done= 1.
  !else !if (!measure='CLARK') !then !let !lab= 'DISSIMILARITY CLARK'
-  loop i= 1 to nrow(data).
-   comp di= data(i,:)(ones,:).
-   comp tdi= t(di).
-   comp diptdi= abs(di)+abs(tdi).
-   comp di= (di-tdi)/(diptdi+(diptdi=0)).
-   comp cumd= cumd+di&*di.
-  end loop.
-  comp cumd= !sqrt(cumd).
-  comp done= 1.
  !else !if (!measure='BRAYCURT') !then !let !lab= 'DISSIMILARITY BRAY-CURTIS'
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else if rsum(csum(data)=0)>1.
-   print /title '>ERROR. Among vectors to compute proximity between, there are more than one - zero.'.
-  else.
-   loop i= 1 to nrow(data).
-    comp di= data(i,:)(ones,:).
-    comp cumd= cumd+abs(di-t(di)).
-   end loop.
-   comp denom= csum(data)(make(1,ncol(data),1),:).
-   comp cumd= cumd/(denom+t(denom)).
-   comp done= 1.
-  end if.
  !else !if (!measure='SOERGEL' !or !measure='KULCZ1') !then
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   comp denom= make(ncol(data),ncol(data),0).
-   loop i= 1 to nrow(data).
-    comp di= data(i,:)(ones,:).
-    comp tdi= t(di).
-    comp cumd= cumd+abs(di-tdi).
-    comp dgetd= di>=tdi.
     !if (!measure='SOERGEL') !then !let !lab= 'DISSIMILARITY SOERGEL' 
-     comp denom= denom+(dgetd&*di+(not dgetd)&*tdi).        
     !else !let !lab= 'DISSIMILARITY KULCZYNSKI 1'
-     comp denom= denom+((not dgetd)&*di+dgetd&*tdi).
     !ifend
-   end loop.
-   do if all(denom).
-    comp cumd= cumd/denom.
-    comp done= 1.
-   else.
-    print /title '>ERROR. The denominator of the formula is sometimes zero.'.
-   end if.
-  end if.
  !else !if (!measure='HEDGES') !then
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   loop i= 1 to nrow(data).
-    comp di= data(i,:)(ones,:).
-    comp tdi= t(di).
-    comp dgetd= di>=tdi.
-    comp max= dgetd&*di+(not dgetd)&*tdi.
-    comp cumd= cumd+abs(di-tdi)/(max+(max=0)).
-   end loop.
-   comp done= 1.
-  end if.
  !else !if (!head(!measure)='PINKH') !then !let !lab= 'SIMILARITY PINKHAM-PEARSON i=0'
   !if (!tail(!measure)=' 1') !then !let !pmax0= '+(max=0)' !let !lab= 'SIMILARITY PINKHAM-PEARSON i=1' !ifend
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   loop i= 1 to nrow(data).
-    comp di= data(i,:)(ones,:).
-    comp tdi= t(di).
-    comp dgetd= di>=tdi.
-    comp max= dgetd&*di+(not dgetd)&*tdi.
-    comp cumd= cumd+((not dgetd)&*di+dgetd&*tdi !pmax0)/(max+(max=0)).
-   end loop.
-   comp cumd= cumd/nrow(data).
-   comp done= 1.
-  end if.
  !else !if (!measure='ROBERTS') !then !let !lab= 'SIMILARITY ROBERTS'
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else if rsum(csum(data)=0)>1.
-   print /title '>ERROR. Among vectors to compute proximity between, there are more than one - zero.'.
-  else.
-   comp denom= make(ncol(data),ncol(data),0).
-   loop i= 1 to nrow(data).
-    comp di= data(i,:)(ones,:).
-    comp tdi= t(di).
-    comp diptdi= di+tdi.
-    comp dgetd= di>=tdi.
-    comp max= dgetd&*di+(not dgetd)&*tdi.
-    comp cumd= cumd+diptdi&*(((not dgetd)&*di+dgetd&*tdi)/(max+(max=0))).
-   comp denom= denom+diptdi.
-   end loop.
-   comp cumd= cumd/denom.
-   comp done= 1.
-  end if.
  !else !if (!measure='KULCZ2') !then !let !lab= 'DISSIMILARITY KULCZYNSKI 2'
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   comp sum= csum(data).
    do if any(sum=0).
-    print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-   else.
-    loop i= 1 to nrow(data).
-     comp di= data(i,:)(ones,:).
-     comp tdi= t(di).
-     comp dgetd= di>=tdi.
-     comp cumd= cumd+(not dgetd)&*di+dgetd&*tdi.
-    end loop.
-    comp sum= (1/sum)(ones,:).
-    comp cumd= 1-cumd/2&*(sum+t(sum)).
-    call setdiag(cumd,0).
-    comp done= 1.
-   end if.
-  end if.
  !else !if (!measure='INTERSECT') !then !let !lab= 'SIMILARITY INTERSECTION'
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   comp sum= csum(data).
    do if any(sum=0).
-    print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-   else.
-    comp denom= make(ncol(data),ncol(data),0).
-    loop i= 1 to nrow(data).
-     comp di= data(i,:)(ones,:).
-     comp tdi= t(di).
-     comp dgetd= di>=tdi.
-     comp cumd= cumd+((not dgetd)&*di+dgetd&*tdi).
-    end loop.
-    comp di= make(ncol(sum),1,1)*sum.
-    comp tdi= t(di).
-    comp dgetd= di>=tdi.
-    comp cumd= cumd/((not dgetd)&*di+dgetd&*tdi).
-    comp done= 1.
-   end if.
-  end if.
  !else !if (!measure='COS' !or !measure='CHORD') !then !let !lab= 'SIMILARITY COSINE'
-  comp cumd= sscp(data).
-  comp ss= diag(cumd).
   do if any(ss=0).
-   print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-  else.
-   comp cumd= cumd/sqrt(ss*t(ss)).
    !if (!measure='CHORD') !then !let !lab= 'DISSIMILARITY CHORD'
-    comp cumd= !sqrt(2*(1-cumd)).
    !ifend
-   comp done= 1.
-  end if.
  !else !if (!measure='EUCLID') !then !let !lab= 'DISSIMILARITY EUCLID'
-  comp cumd= sscp(data).
-  comp ss= diag(cumd)*make(1,ncol(data),1).
-  comp cumd= ss+t(ss)-2*cumd.
-  comp cumd= !sqrt(cumd&*(cumd>0)).
-  comp done= 1.
  !else !if (!measure='SIZE') !then !let !lab= 'DISSIMILARITY PENROSE SIZE DIFF'
   !let !symm= 0
-  comp cumd= (csum(data)/sqrt(nrow(data)))(ones,:).
-  comp cumd= cumd-t(cumd).
-  comp done= 1.
  !else !if (!measure='SCATTER') !then !let !lab= 'DISSIMILARITY SCATTER DIFF'
   !let !symm= 0
-  comp sum= csum(data).
-  comp cumd= sqrt(cssq(data)-sum&*sum/nrow(data))(ones,:).
-  comp cumd= cumd-t(cumd).
-  comp done= 1.
  !else !if (!measure='SHAPE' !or !measure='ZSHAPE') !then !let !lab= 'DISSIMILARITY PENROSE SHAPE'
-  comp data= data-(csum(data)/nrow(data))(make(1,nrow(data),1),:).
   !if (!measure='ZSHAPE') !then !let !lab= 'DISSIMILARITY STANDARDIZED SHAPE'
-   comp data= data/sqrt(cssq(data)/nrow(data))(make(1,nrow(data),1),:).
   !ifend
-  comp cumd= sscp(data).
-  comp ss= diag(cumd)*make(1,ncol(data),1).
-  comp cumd= ss+t(ss)-2*cumd.
-  comp cumd= !sqrt(cumd&*(cumd>0)).
-  comp done= 1.
  !else !if (!measure='SIN') !then !let !lab= 'DISSIMILARITY SINE'
-  comp cumd= sscp(data).
-  comp ss= diag(cumd).
   do if any(ss=0).
-   print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-  else.
-   comp cumd= cumd/sqrt(ss*t(ss)).
-   comp cumd= !sqrt(1-cumd&*cumd).
-   comp done= 1.
-  end if.
  !else !if (!measure='ARCCOS') !then !let !lab= 'DISSIMILARITY ARCCOS'
-  comp cumd= sscp(data).
-  comp ss= diag(cumd).
   do if any(ss=0).
-   print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-  else.
-   comp cumd= cumd/sqrt(ss*t(ss)).
-   comp cumd= 1.570796326794897-arsin(cumd).
-   call setdiag(cumd,0).
-   comp done= 1.
-  end if.
  !else !if (!measure='SIMRATIO') !then !let !lab= 'SIMILARITY SIMILARITY RATIO'
-  comp cumd= sscp(data).
-  comp ss= diag(cumd).
   do if any(ss=0).
-   print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-  else.
-   comp ss= ss*make(1,ncol(cumd),1).
-   comp cumd= cumd/(ss+t(ss)-cumd).
-   comp done= 1.
-  end if.
  !else !if (!measure='IDENTC') !then !let !lab= 'SIMILARITY IDENTITY COEF'
-  comp cumd= sscp(data).
-  comp ss= diag(cumd).
   do if any(ss=0).
-   print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-  else.
-   comp ss= ss*make(1,ncol(cumd),1).
-   comp cumd= 2*cumd/(ss+t(ss)).
-   comp done= 1.
-  end if.
  !else !if (!measure='MORHORN') !then !let !lab= 'SIMILARITY MORISITA-HORN'
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   comp sum= csum(data).
-   do if any(sum=0).
-    print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-   else.
-    comp cumd= sscp(data).
-    comp ss= t(diag(cumd)).
-    comp denom= (ss/sum)(ones,:).
-    comp denom= denom&*t(sum(ones,:)).
-    comp denom= denom+t(denom).
-    comp cumd= 2*cumd/denom.
-    call setdiag(cumd,1).
-    comp done= 1.
-   end if.
-  end if.
  !else !if (!measure='ELLENBERG' !or !measure='GLEASON') !then
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else if any(csum(data)=0).
-   print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-  else.
-   comp denom= make(ncol(data),ncol(data),0).
-   loop i= 1 to nrow(data).
-    comp di= data(i,:).
-    comp spip= sscp(di)>0.
-    comp di= di(ones,:).
-    comp ditdi= di+t(di).
-    comp cumd= cumd+ditdi&*spip.
     !if (!measure='ELLENBERG') !then !let !lab= 'SIMILARITY ELLENBERG'
-     comp denom= denom+ditdi&*(2-spip).
     !else !let !lab= 'SIMILARITY GLEASON'
-     comp denom= denom+ditdi.
     !ifend
-   end loop.
-   comp cumd= cumd/denom.
-   comp done= 1.
-  end if.
  !else !if (!measure='PANDEYA') !then !let !lab= 'SIMILARITY PANDEYA'
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   comp sum= csum(data).
-   do if any(sum=0).
-    print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-   else.
-    comp denom= make(ncol(data),ncol(data),0).
-    loop i= 1 to nrow(data).
-     comp di= data(i,:).
-     comp spip= sscp(di)>0.
-     comp di= di(ones,:).
-     comp tdi= t(di).
-     comp cumd= cumd+(di+tdi)&*spip.
-     comp denom= denom+abs(di-tdi)&*spip.
-    end loop.
-    comp sum= sum(ones,:).
-    comp cumd= cumd/(sum+t(sum)+denom).
-    comp done= 1.
-   end if.
-  end if.
  !else !if (!measure='HMEAN') !then !let !lab= 'SIMILARITY HARMONIC MEAN'
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   loop i= 1 to nrow(data).
-    comp di= data(i,:)(ones,:).
-    comp tdi= t(di).
-    comp diptdi= di+tdi.
-    comp cumd= cumd+di&*tdi/(diptdi+(diptdi=0)).
-   end loop.
-   comp cumd= 2*cumd.
-   comp done= 1.
-  end if.
  !else !if (!measure='GMEAN') !then !let !lab= 'SIMILARITY GEOMETRIC MEAN'
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   comp cumd= sscp(sqrt(data)).
-   comp done= 1.
-  end if.
  !else !if (!measure='BHATTACH') !then !let !lab= 'DISSIMILARITY BHATTACHARYYA'
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   comp sum= csum(data).
-   do if any(sum=0).
-    print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-   else.
-    comp data= data/sum(make(1,nrow(data),1),:).
-    comp cumd= sscp(sqrt(data)).
-    do if any(cumd<=0).
-     print /title '>ERROR. Some proximities occured zero before logarithming.'.
-    else.
-     comp cumd= -ln(cumd).
-     call setdiag(cumd,0).
-     comp done= 1.
-    end if.
-   end if.
-  end if.
  !else !if (!measure='HELLINGER') !then !let !lab= 'DISSIMILARITY HELLINGER'
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   comp sum= csum(data).
-   do if any(sum=0).
-    print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-   else.
-    comp data= data/sum(make(1,nrow(data),1),:).
-    comp cumd= 1-sscp(sqrt(data)).
-    comp cumd= cumd&*(abs(cumd)>=1E-14).
-    comp cumd= 2*sqrt(cumd).
-    call setdiag(cumd,0).
-    comp done= 1.
-   end if.
-  end if.
  !else !if ((!measure='MAHAL' !or !measure='MAHAL2') !and !matrix=!null) !then !let !lab= 'DISSIMILARITY MAHALANOBIS'
-  comp data= t(data).
   !if (!measure='MAHAL') !then
    !let !ineq= '<=' !let !err1= '>ERROR. The matrix is singular because the number of vectors is not greater than their length.'
    !let !err2= '>ERROR. The matrix is singular. There are linear dependences.'
    !let !df= '-1'
   !else
    !let !ineq= '<' !let !err1= '>ERROR. The matrix is singular because the number of vectors is less than their length.'
    !let !err2= '>ERROR. The matrix is singular. There are proportional dependences.'
   !ifend
-  do if nrow(data) !ineq ncol(data).
-   print /title !quote(!err1).
-  else.
    !if (!measure='MAHAL') !then
-    comp data= data-(csum(data)/nrow(data))(make(1,nrow(data),1),:).
    !ifend
-   comp cumd= 0.
-   comp cumd= data*solve(sscp(data),t(data))*(nrow(data) !df).
-   do if nrow(cumd)*ncol(cumd)=1.
-    print /title !quote(!err2).
-   else.
-    comp hsq= diag(cumd)*make(1,ncol(cumd),1).
-    comp cumd= hsq+t(hsq)-2*cumd.
-    comp cumd= !sqrt(cumd&*(cumd>0)).
-    comp done= 1.
-   end if.
-  end if.
  !else !if (!measure='CHISQPR') !then !let !lab= 'DISSIMILARITY CHI-SQUARE (FOR PROB)'
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   comp sum= csum(data).
-   do if any(sum=0).
-    print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-   else.
-    comp data= data/sum(make(1,nrow(data),1),:).
-    loop i= 1 to nrow(data).
-     comp di= data(i,:)(ones,:).
-     comp tdi= t(di).
-     comp dimtdi= di-tdi.
-     comp diptdi= di+tdi.
-     comp cumd= cumd+dimtdi&*dimtdi/(diptdi+(diptdi=0)).
-    end loop.
-    comp cumd= !sqrt(cumd).
-    comp done= 1.
-   end if.
-  end if.
  !else !if (!measure='PNDIV' !or !measure='SPNDIV') !then !let !lab= 'DISSIMILARITY PEARSON-NEYMAN DIVERGENCE (ASYMMETRIC)'
   !let !symm= 0
-  do if any(data<=0).
-   print /title '>ERROR. Data have nonpositive values.'.
-  else.
-   comp sum= csum(data).
-   do if any(sum=0).
-    print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-   else.
-    comp data= data/sum(make(1,nrow(data),1),:).
-    loop i= 1 to nrow(data).
-     comp di= data(i,:)(ones,:).
-     comp tdi= t(di).
-     comp dimtdi= di-tdi.
-     comp cumd= cumd+dimtdi&*dimtdi/tdi. 
-    end loop.
     !if (!measure='SPNDIV') !then !let !lab= 'DISSIMILARITY PEARSON-NEYMAN DIVERGENCE (SYMMETRIC)'
-     comp cumd= (cumd+t(cumd))/2.
     !ifend
-    comp cumd= !sqrt(cumd).
-    comp done= 1.
-   end if.
-  end if.
  !else !if (!measure='KLDIV' !or !measure='SKLDIV') !then !let !lab= 'DISSIMILARITY KULLBACK–LEIBLER DIVERGENCE (ASYMMETRIC)'
   !let !symm= 0
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   comp sum= csum(data).
-   do if any(sum=0).
-    print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-   else.
-    comp data= data/sum(make(1,nrow(data),1),:).
-    loop i= 1 to nrow(data).
-     comp di= data(i,:).
-     comp w= di>0.
-     comp di= di+(not w).
-     comp di= di(ones,:).
-     comp cumd= cumd+sscp(w)&*(di&*ln(di/t(di))).
-    end loop.
     !if (!measure='SKLDIV') !then !let !lab= 'DISSIMILARITY KULLBACK–LEIBLER DIVERGENCE (SYMMETRIC)'
-     comp cumd= cumd+t(cumd).
     !ifend
-    comp done= 1.
-   end if.
-  end if.
  !else !if (!measure='KDIV' !or !measure='SKDIV') !then !let !lab= 'DISSIMILARITY K-DIVERGENCE (ASYMMETRIC)'
   !let !symm= 0
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   comp sum= csum(data).
-   do if any(sum=0).
-    print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-   else.
-    comp data= data/sum(make(1,nrow(data),1),:).
-    loop i= 1 to nrow(data).
-     comp di= data(i,:).
-     comp w= di>0.
-     comp di= di+(not w).
-     comp di= di(ones,:).
-     comp cumd= cumd+sscp(w)&*(di&*ln(2*di/(di+t(di)))).
-    end loop.
     !if (!measure='SKDIV') !then !let !lab= 'DISSIMILARITY K-DIVERGENCE (SYMMETRIC)'
-     comp cumd= cumd+t(cumd).
     !ifend
-    comp done= 1.
-   end if.
-  end if.
  !else !if (!measure='JDIFF') !then !let !lab= 'DISSIMILARITY JENSEN DIFFERENCE'
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   comp sum= csum(data).
-   do if any(sum=0).
-    print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-   else.
-    comp data= data/sum(make(1,nrow(data),1),:).
-    loop i= 1 to nrow(data).
-     comp di= data(i,:).
-     comp w= di>0.
-     comp di= di+(not w).
-     comp di= di(ones,:).
-     comp diptdi= (di+t(di))/2.
-     comp di= di&*ln(di)/2.
-     comp cumd= cumd+sscp(w)&*(di+t(di)-diptdi&*ln(diptdi)).
-    end loop.
-    comp done= 1.
-   end if.
-  end if.
  !else !if (!measure='TANEJA') !then !let !lab= 'DISSIMILARITY TANEJA'
-  do if any(data<0).
-   print /title '>ERROR. Data have negative values.'.
-  else.
-   comp sum= csum(data).
-   do if any(sum=0).
-    print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-   else.
-    comp data= data/sum(make(1,nrow(data),1),:).
-    loop i= 1 to nrow(data).
-     comp di= data(i,:).
-     comp w= di>0.
-     comp di= di+(not w).
-     comp di= di(ones,:).
-     comp tdi= t(di).
-     comp diptdi= (di+tdi)/2.
-     comp cumd= cumd+sscp(w)&*(diptdi&*ln(diptdi/sqrt(di&*tdi))).
-    end loop.
-    comp done= 1.
-   end if.
-  end if.
  !else !if (!measure='CATRP') !then !let !lab= 'SIMILARITY CATTELL PATTERN'
-  comp cumd= sscp(data).
-  comp ss= diag(cumd)*make(1,ncol(data),1).
-  comp cumd= ss+t(ss)-2*cumd.
-  comp q= 2*nrow(data)*(1-2/(9*nrow(data)))**3.
-  comp cumd= (q-cumd)/(q+cumd).
-  comp done= 1.
  !else !if (!measure='MCRPA') !then !let !lab= 'SIMILARITY MCCRAE PROFILE'
-  do if nrow(data)<3.
-   print /title '>ERROR. This measure requires vectors of length >2.'.
-  else.
-   comp cumd= sscp(data).
-   comp ss= diag(cumd)*make(1,ncol(data),1).
-   comp sqs= ss+t(ss)+2*cumd.
-   comp cumd= ss+t(ss)-2*cumd.
-   comp cumd= (nrow(data)+sqs/2-cumd)/sqrt(10*nrow(data)).
-   comp cumd= cumd/sqrt(nrow(data)-2+cumd&*cumd).
-   comp done= 1.
-  end if.
  !else !if (!measure='ICC') !then !let !lab= 'SIMILARITY INTRACLASS CORRELATION'
-  do if any(cmax(data)=cmin(data)).
-   print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-  else.
-   comp cones= make(nrow(data),1,1).
-   comp ss= cssq(data).
-   loop i= 1 to ncol(cumd)-1.
-    comp datai= data(:,1)*make(1,ncol(cumd)-i,1).
-    comp data= data(:,2:ncol(data)).
-    comp sumij= datai+data.
-    comp tsum= csum(sumij).
-    comp tmean= tsum/(nrow(data)*2).
-    comp tss= ss(i)+ss((i+1):ncol(ss))-tsum&*tmean.
-    comp rtss= cssq(sumij/2-tmean(cones,:)).
-    comp cumd(i,(i+1):ncol(cumd))= 4*rtss/tss-1.
-   end loop.
-   comp cumd= cumd+t(cumd).
-   call setdiag(cumd,1).
-   comp done= 1.
-  end if.
  !else !if ((!head(!measure)='BUTLER' !or !head(!measure)='BUTLER2') !and !matrix=!null) !then !let !lab= 'DISSIMILARITY BUTLER'
-  comp data= t(data).
   !if (!head(!measure)='BUTLER') !then
-   comp data= data-(csum(data)/nrow(data))(make(1,nrow(data),1),:).
   !ifend
-  comp r= sscp(data).
-  comp ss= diag(r).
-  do if any(ss=0).
-   print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-  else.
-   comp r= r/sqrt(ss*t(ss)).
    !if (!tail(!measure)=' INV') !then !let !endif= 'end if' !let !lab= 'DISSIMILARITY BUTLER INV'
-    do if not det(r).
-     print /title '>ERROR. Matrix R in computation of BUTLER/BUTLER2 INV is singular.'.
-    else.
-     comp r= inv(r).
    !ifend
-     comp cumd= data*r*t(data).
-     comp ss= diag(cumd)*make(1,ncol(cumd),1).
-     comp cumd= ss+t(ss)-2*cumd.
-     comp cumd= !sqrt(cumd&*(cumd>0)).
-     comp done= 1.
-    !endif.
-  end if.
  !else !if ((!measure='MAHAL' !or !measure='MAHAL2' !or !head(!measure)='BUTLER' !or !head(!measure)='BUTLER2') !and !matrix<>!null) !then
-  get mx /file= !matrix.
-  do if nrow(mx)<>ncol(mx).
-   print /title '>ERROR. Matrix input by MATRIX subcommand is not square.'.
-  else if nrow(mx)<>nrow(data).
-   print /title '>ERROR. Size of matrix input by s/c MATRIX is not equal to num of dimensions in data.'.
-  else if any(mx<>t(mx)).
-   print /title '>ERROR. Matrix input by MATRIX subcommand is not symmetric.'.
-  else.
    !if (!measure='MAHAL' !or !measure='MAHAL2' !or !tail(!measure)=' INV') !then !let !endif= 'end if'
     !if (!measure='MAHAL' !or !measure='MAHAL2') !then !let !lab= 'DISSIMILARITY MAHALANOBIS' !else !let !lab= 'DISSIMILARITY BUTLER INV' !ifend
-    comp r= 0.
-    comp r= inv(mx).
-    do if nrow(r)*ncol(r)=1.
-     print /title '>ERROR. Matrix input by MATRIX subcommand is singular.'.
-    else.
    !else !let !lab= 'DISSIMILARITY BUTLER'
-     comp r= mx.
    !ifend
-     release mx.
-     comp data= t(data).
-     comp cumd= data*r*t(data).
-     comp ss= diag(cumd)*make(1,ncol(cumd),1).
-     comp cumd= ss+t(ss)-2*cumd.
-     comp cumd= !sqrt(cumd&*(cumd>0)).
-     comp done= 1.
-    !endif.
-  end if.
  !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend
  !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend
-end if.
 !if (!noroot='YES') !then
  !if (!index(' EUCLID CLARK MAHAL MAHAL2 BUTLER BUTLER2 CHORD SIN CHISQPR PNDIV SPNDIV SHAPE ZSHAPE MINK ',!conc(' ',!head(!measure),' '))>0) !then
   !let !lab= !conc(!lab,' [NOROOT]')
  !ifend
 !ifend
-do if done.
  !if (!symm) !then
-  comp cumd= (cumd+t(cumd))/2.
  !ifend
  !if (!abs='YES') !then
-  comp cumd= abs(cumd).
  !ifend
  !if (!reverse<>'NONE' !and !reverse<>!null) !then
   !if (!substr(!lab,1,3)='DIS') !then !let !lab= !conc('SIMILARITY [',!reverse,']',!tail(!lab))
   !else !let !lab= !conc('DISSIMILARITY [',!reverse,']',!tail(!lab))
   !ifend
   !if (!reverse='ONEMINUS') !then
-   comp cumd= 1-cumd.
   !else !if (!reverse='LAWCOS') !then
-   do if cumd(1,1).
-    comp cumd= 1-cumd.
-    comp cumdneg= cumd<0.
-    do if any(cumdneg).
-     print /title '>WARNING. REVERSE=LAWCOS revealed negative values under the sq. root in some elements.'.
-     print /title '>These elements are replaced by -999.' /space= 0.
-     comp cumd= cumd&*(not cumdneg).
-    end if.
-    comp cumd= sqrt(cumd)-999*(cumdneg).
-   else.
-    comp cumd= 1-cumd&*cumd.
-   end if.
   !else !if (!reverse='RECIP') !then
-   do if cumd(1,1).
-    comp cumd0= cumd=0.
-    do if any(cumd0).
-     print /title '>WARNING. REVERSE=RECIP revealed zero values in the denominator in some elements.'.
-     print /title '>These elements are replaced by -999.' /space= 0.
-     comp cumd= cumd+cumd0.
-    end if.
-    comp cumd= 1/cumd-1-999*(cumd0).
-   else.
-    comp cumd= 1/(cumd+1).
-   end if.
   !else
-   do if cumd(1,1).
-    call setdiag(cumd,0).
-    comp cumd= -cumd.
-    comp cumd= cumd-mmin(cumd).
-    call setdiag(cumd,0).
-   else.
-    comp cumd= -cumd.
-    comp min= mmin(cumd).
-    comp cumd= cumd-min+(min=0).
-   end if.
   !ifend !ifend !ifend
  !ifend
  !if (!view='VARIABLE') !then
-  comp rowtype= make(nrow(cumd),1,'PROX').
-  comp cn= {'rowtype_','varname_',names}.
-  save {rowtype,t(names),cumd} /out= * /names= cn /strings= rowtype_ varname_.
  !else
-  save {id,case,cumd} /out= * /vari= !iddd caseno_ var1 to var50000 /string= !iddd.
  !ifend
-else.
- print /title '>!KO_PROXQNT is executed incorrectly.' /space= 0.
- save 0 /out= *.
-end if.
-end matrix.
-set results none errors none.
 !if (!view<>'VARIABLE') !then
- matrix.
- get m /names= names.
- do if ncol(m)>1.
-  comp rowtype= make(nrow(m),1,'PROX').
-  comp cn= {'rowtype_',!quote(!iddd),'caseno_','varname_',names(3:ncol(names))}.
-  save {rowtype,m(:,1:2),t(names(3:ncol(names))),m(:,3:ncol(m))} /out= * /names= cn /strings= rowtype_ !iddd varname_.
- end if.
- end matrix.
 !ifend
-format all (f8.3).
-!fcaseno.
-set results list errors list.
-var lev all (sca) rowtype_ to varname_ (nom).
-val lab rowtype_ 'PROX' !quote(!lab).
!ifend
!enddefine.

*/*!KO_PROXBIN*/vers1***************************************************************************.
define !KO_proxbin(vars= !charend('/') /view= !charend('/') /id= !charend('/') /measure= !charend('/') /adjust= !charend('/') /abs= !charend('/') /reverse= !charend('/'))
!if (!view='VARIABLE' !and !id<>!null) !then
-echo ''.
-echo '>ERROR. Specifying ID is incompatible with VIEW=VARIABLE. !KO_PROXBIN is executed incorrectly.'.
-new file.
!else !if (!adjust<>'NONE' !and !adjust<>!null !and
          (!measure='LW' !or !measure='SEUCLID' !or !measure='EUCLID' !or !measure='SIZE' !or !measure='SHAPE' !or !measure='PATTERN'
           !or !measure='VARIANCE' !or !measure='MN' !or !measure='QDIFF' !or !measure='CHORD' !or !measure='HELLINGER')) !then
-echo ''.
-echo !quote(!conc('>ERROR. MEASURE=',!measure,' is dissimilarity. Dissimilarities demand ADJUST=NONE. !KO_PROXBIN is executed incorrectly.')).
-new file.
!else !if ((!adjust='MARGPOLE' !or !adjust='INDMARGPOLE' !or !adjust='INDMARGMAX') !and !measure='MOUNTF') !then
-echo ''.
-echo '>ERROR. MEASURE=MOUNTF is incompatible with ADJUST= MARGPOLE/INDMARGPOLE/INDMARGMAX.'.
-echo '>!KO_PROXBIN is executed incorrectly.'.
-new file.
!else
 !if (!view<>'VARIABLE') !then !let !caseno= 'caseno#$' !let !fcaseno= 'format caseno_ (f8)'
- set errors none.
- temp.
- comp caseno#$= $casenum.
  !if (!id=!null) !then !let !idd= 'strid#$' !let !iddd= 'id'
-  string strid#$ (a8).
-  comp strid#$= concat('C',ltrim(string(caseno#$,f8))).
  !else !let !idd= !id !let !iddd= !id
  !ifend
 !ifend
-set mxloops 100000 errors list.
-matrix.
-get data /vari= !idd !caseno !vars /names= names /miss= omit.
 !if (!view<>'VARIABLE') !then !let !idnam= 'id'
- comp id= data(:,1).
- comp case= data(:,2).
- comp data= data(:,3:ncol(data)).
- comp names= names(3:ncol(names)).
- comp data= t(data).
 !else !let !idnam= 'names'
 !ifend
!if (!measure='LW' !or !measure='SEUCLID' !or !measure='EUCLID' !or !measure='SIZE' !or !measure='SHAPE' !or !measure='PATTERN'
     !or !measure='VARIANCE' !or !measure='MN' !or !measure='QDIFF' !or !measure='CHORD' !or !measure='HELLINGER') !then !let !simil= 0
!else !let !simil= 1
!ifend
-comp done= 0.
-do if ncol(data)=1.
- print /title '>ERROR. Number of items between which to compute proximity is less than 2.'.
-else if nrow(data)=1.
- print /title '>ERROR. Length of vectors is less than 2.'.
-else if any((data&*data)<>data).
- print /title '>ERROR. The data are not binary (1 vs 0).'.
-else.
- comp uplim= 1.
- comp lolim= 0.
- comp m= nrow(data).
- comp a#= sscp(data).
- comp b#= csum(data)(make(1,ncol(data),1),:)-a#.
- release data.
  !if (!index(!measure,'_')<>0) !then
-   comp c#= t(b#).
-   comp d#= m-a#-b#-c#.
   !if (!measure='COUNT_A') !then !let !lab= 'SIMILARITY COUNT A'
-   comp cumd= a#.
   !else !if (!measure='COUNT_D') !then !let !lab= 'SIMILARITY COUNT D'
-   comp cumd= d#.
   !else !if (!measure='COUNT_B') !then !let !lab= 'DISSIMILARITY COUNT B'
-   comp cumd= b#.
   !else !if (!measure='COUNT_C') !then !let !lab= 'DISSIMILARITY COUNT C'
-   comp cumd= c#.
   !else !if (!measure='ECOUNT_A') !then !let !lab= 'SIMILARITY EXPECTED COUNT A'
-   comp cumd= (a#+b#)&*(a#+c#)/m.
   !else !if (!measure='ECOUNT_D') !then !let !lab= 'SIMILARITY EXPECTED COUNT D'
-   comp cumd= (d#+c#)&*(d#+b#)/m.
   !else !if (!measure='ECOUNT_B') !then !let !lab= 'DISSIMILARITY EXPECTED COUNT B'
-   comp cumd= (b#+a#)&*(b#+d#)/m.
   !else !if (!measure='ECOUNT_C') !then !let !lab= 'DISSIMILARITY EXPECTED COUNT C'
-   comp cumd= (c#+d#)&*(c#+a#)/m.
   !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend
-  comp done= 1.
  !else
   !if (!adjust='INDBOUND' !or !adjust='INDUPPER') !then !let !cumdlst= 'cumd bcumd'
   !else !if (!adjust='MARGPOLE') !then !let !cumdlst= 'cumd pcumd'
   !else !if (!adjust='INDMARGPOLE' !or !adjust='INDMARGMAX') !then !let !cumdlst= 'cumd bcumd pcumd'
   !else !let !cumdlst= 'cumd'
   !ifend !ifend !ifend
   !if (!adjust='MARGPOLE' !or !adjust='INDMARGPOLE') !then !let !numsgn= '&*numsgn' !ifend
-  comp bcumd= 0.
   !do !cumd !in (!cumdlst)
    !if (!cumd='cumd') !then
-    comp a= a#.
-    comp b= b#.
-    comp c= t(b#).
-    comp d= m-a-b-c.
    !else
-    do if done.
     !if (!cumd='bcumd') !then
-     comp c= t(b#).
-     comp d= m-a#-b#-c.
-     comp a= (a#+b#)&*(a#+c)/m.
-     comp b= (a#+b#)&*(b#+d)/m.
-     comp c= (c+d)&*(a#+c)/m.
-     comp d= m-a-b-c.
     !else !if (!cumd='pcumd') !then
-     comp cumd= cumd-bcumd.
-     comp numsgn= cumd>=0.
-     comp c#= t(b#).
-     comp d#= m-a#-b#-c#.
-     comp min= b#&*(b#<c#)+c#&*(b#>=c#).
-     comp a= (a#+min)!numsgn.
-     comp b= (b#-min)!numsgn.
-     comp c= (c#-min)!numsgn.
-     comp d= (d#+min)!numsgn.
-     comp numsgn= (not numsgn).
      !if (!adjust<>'INDMARGMAX') !then
-      comp min= a#&*(a#<d#)+d#&*(a#>=d#).
-      comp a= a+(a#-min)&*numsgn.
-      comp b= b+(b#+min)&*numsgn.
-      comp c= c+(c#+min)&*numsgn.
-      comp d= d+(d#-min)&*numsgn.
      !ifend
-     release a#,b#,c#,d#,numsgn,min.
     !ifend !ifend
    !ifend
-   comp sum= diag(a).
    !if (!measure='RR') !then !let !lab= 'SIMILARITY RUSSEL-RAO (1 0)'
-    comp !cumd= a/m.
-    comp done= 1.
    !else !if (!measure='SM') !then !let !lab= 'SIMILARITY SIMPLE MATCHING (1 0)'
-    comp !cumd= (a+d)/m.
-    comp done= 1.
    !else !if (!measure='JACCARD') !then !let !lab= 'SIMILARITY JACCARD (1 0)'
-    do if csum(sum=0)>1.
-     print /title '>ERROR. Among vectors to compute proximity between, there are more than one - zero.'.
-    else.
-     comp !cumd= a+b+c.
-     comp abc0= !cumd=0.
-     comp !cumd= (a+abc0)/(!cumd+abc0).
-     comp done= 1.
-     release abc0.
-    end if.
    !else !if (!measure='DICE' !or !measure='LW') !then
-    do if csum(sum=0)>1.
-     print /title '>ERROR. Among vectors to compute proximity between, there are more than one - zero.'.
-    else.
-     comp !cumd= 2*a+b+c.
-     comp abc0= !cumd=0.
-     comp !cumd= (2*a+abc0)/(!cumd+abc0).
      !if (!measure='DICE') !then !let !lab= 'SIMILARITY DICE (1 0)'
      !else !let !lab= 'DISSIMILARITY LANCE-WILLIAMS (1 0)'
-      comp !cumd= 1-!cumd.
      !ifend
-     comp done= 1.
-     release abc0.
-    end if.
    !else !if (!measure='RT') !then !let !lab= 'SIMILARITY ROGERS-TANIMOTO (1 0)'
-    comp !cumd= (a+d)/(m+b+c).
-    comp done= 1.
    !else !if (!measure='SS1') !then !let !lab= 'SIMILARITY SOKAL-SNEATH 1 (1 0)'
-    comp !cumd= 2*(a+d)/(2*(a+d)+b+c).
-    comp done= 1.
    !else !if (!measure='SS2') !then !let !lab= 'SIMILARITY SOKAL-SNEATH 2 (1 0)'
-    do if csum(sum=0)>1.
-     print /title '>ERROR. Among vectors to compute proximity between, there are more than one - zero.'.
-    else.
-     comp !cumd= a+2*(b+c).
-     comp abc0= !cumd=0.
-     comp !cumd= (a+abc0)/(!cumd+abc0).
-     comp done= 1.
-     release abc0.
-    end if.
    !else !if (!measure='K1' !or !measure='SS3') !then
-    comp !cumd= b+c.
-    call setdiag(!cumd,1).
-    comp cumd0= !cumd=0.
-    do if any(cumd0).
-     print /title '>ERROR. The denominator of the formula is sometimes zero.'.
-     comp cumd0= rmax(cumd0&*(1:ncol(cumd0))(make(1,ncol(cumd0),1),:)).
-     loop i= 1 to nrow(cumd0).
-     end loop if cumd0(i).
-     print !idnam({i,cumd0(i)}) /title '>The problem is in this pair of vectors:' /format= a8 /space= 0.
      !if (!cumd<>'cumd') !then
-      print /title '>The problem occured not at computation but at rescaling (s/c ADJUST) of the measure.' /space= 0.
-      comp done= 0.
      !ifend
-    else.
      !if (!measure='K1') !then !let !lab= 'SIMILARITY KULCZYNSKI 1 (1 0)'
-      comp !cumd= a/!cumd.
      !else !let !lab= 'SIMILARITY SOKAL-SNEATH 3 (1 0)'
-      comp !cumd= (a+d)/!cumd.
      !ifend
-     call setdiag(!cumd,1).
-     comp done= 1.
-     comp uplim= m-1.
-    end if.
    !else !if (!measure='K2') !then !let !lab= 'SIMILARITY KULCZYNSKI 2 (1 0)'
-    do if any(sum=0).
-     print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-    else.
-     comp !cumd= (a/(a+b)+a/(a+c))/2.
-     comp done= 1.
-    end if.
    !else !if (!measure='MCCON') !then !let !lab= 'SIMILARITY MCCONNAUGHEY (1 0)'
-    do if any(sum=0).
-     print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-    else.
-     comp !cumd= (a&*a-b&*c)/((a+b)&*(a+c)).
-     comp done= 1.
-     comp lolim= -1.
-    end if.
    !else !if (!measure='OCHIAI' !or !measure='SORG' !or !measure='CHORD' !or !measure='HELLINGER') !then
-    do if any(sum=0).
-     print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-    else.
-     comp !cumd= a/sqrt((a+b)&*(a+c)).
      !if (!measure='OCHIAI') !then !let !lab= 'SIMILARITY OCHIAI (COSINE) (1 0)'
      !else !if (!measure='CHORD') !then !let !lab= 'DISSIMILARITY CHORD DIST (1 0)'
-      comp !cumd= sqrt(2*(1-!cumd)).
      !else !let !lab= 'DISSIMILARITY HELLINGER DIST (1 0)'
-      comp !cumd= 2*sqrt(1-!cumd).
      !ifend !ifend
-     comp done= 1.
-    end if.
    !else !if (!measure='SS4') !then !let !lab= 'SIMILARITY SOKAL-SNEATH 4 (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp !cumd= (a/(a+b)+a/(a+c)+d/(b+d)+d/(c+d))/4.
-     comp done= 1.
-    end if.
    !else !if (!measure='SS5') !then !let !lab= 'SIMILARITY SOKAL-SNEATH 5 (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp !cumd= a&*d/sqrt((a+b)&*(a+c)&*(b+d)&*(c+d)).
-     comp done= 1.
-    end if.
    !else !if (!measure='GOWER') !then !let !lab= 'SIMILARITY BINARY GOWER (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp !cumd= (a+d)/sqrt((a+b)&*(a+c)&*(b+d)&*(c+d)).
-     comp done= 1.
-     comp uplim= m/(m-1).
-    end if.
    !else !if (!measure='HAMANN') !then !let !lab= 'SIMILARITY HAMANN (1 0)'
-    comp !cumd= ((a+d)-(b+c))/m.
-    comp done= 1.
-    comp lolim= -1.
    !else !if (!measure='CHISQ' !or !measure='CC') !then !let !lab= 'SIMILARITY CHI-SQUARE (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp !cumd= a&*d-b&*c.
-     comp !cumd= m*!cumd&*!cumd/((a+b)&*(a+c)&*(b+d)&*(c+d)).
-     comp uplim= m.
      !if (!measure='CC') !then !let !lab= 'SIMILARITY CONTINGENCY COEF (1 0)'
-      comp !cumd= sqrt(!cumd/(!cumd+m)).
-      comp uplim= sqrt(.5).
      !ifend
-     comp done= 1.
-    end if.
    !else !if (!measure='CHISQY') !then !let !lab= 'SIMILARITY CHI-SQUARE, YATES (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
      !if (!cumd<>'cumd') !then
-      print /title '>The problem occured not at computation but at rescaling (s/c ADJUST) of the measure.' /space= 0.
-      print /title '>Remove from the input data vectors which are close to be constants.' /space= 0.
-      comp done= 0.
      !ifend
-    else.
-     comp !cumd= abs(a&*d-b&*c)-m/2.
-     comp !cumd= m*!cumd&*!cumd/((a+b)&*(a+c)&*(b+d)&*(c+d)).
-     comp done= 1.
-     comp uplim= m.
-    end if.
    !else !if (!measure='PHI') !then !let !lab= 'SIMILARITY PHI CORR (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp !cumd= (a&*d-b&*c)/sqrt((a+b)&*(a+c)&*(b+d)&*(c+d)).
-     comp done= 1.
-     comp lolim= -1.
-    end if.
    !else !if (!measure='PRPHI') !then !let !lab= 'SIMILARITY POLE-RESCALED PHI CORR (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp apb= a+b.
-     comp apc= a+c.
-     comp cpd= c+d.
-     comp bpd= b+d.
-     comp !cumd= a&*d-b&*c.
-     comp adgebc= !cumd>=0.
-     comp x= (apb&*bpd)&*adgebc+(apb&*apc)&*(not adgebc).
-     comp y= (apc&*cpd)&*adgebc+(cpd&*bpd)&*(not adgebc).
-     comp !cumd= !cumd/(x&*(x<y)+y&*(x>=y)).
-     comp done= 1.
      comp lolim= -1.
-     release apb,apc,cpd,bpd.
-    end if.
    !else !if (!measure='DISPER') !then !let !lab= 'SIMILARITY DISPER (1 0)'
-    comp !cumd= (a&*d-b&*c)/m&**2.
-    comp done= 1.
-    comp uplim= .25.
-    comp lolim= -.25.
    !else !if (!measure='SEUCLID') !then !let !lab= 'DISSIMILARITY SQUARED EUCLIDEAN DIST (1 0)'
-    comp !cumd= b+c.
-    comp done= 1.
    !else !if (!measure='EUCLID') !then !let !lab= 'DISSIMILARITY EUCLIDEAN DIST (1 0)'
-    comp !cumd= sqrt(b+c).
-    comp done= 1.
    !else !if (!measure='SIZE') !then !let !lab= 'DISSIMILARITY SIZE DIFF (1 0)'
-    comp !cumd= b-c.
-    comp !cumd= (!cumd&*!cumd)/m**2.
-    comp done= 1.
    !else !if (!measure='SHAPE') !then !let !lab= 'DISSIMILARITY SHAPE DIFF (1 0)'
-    comp !cumd= b-c.
-    comp !cumd= (m*(b+c)-!cumd&*!cumd)/m**2.
-    comp done= 1.
    !else !if (!measure='PATTERN') !then !let !lab= 'DISSIMILARITY PATTERN DIFF (1 0)'
-    comp !cumd= b&*c/m**2.
-    comp done= 1.
    !else !if (!measure='VARIANCE') !then !let !lab= 'DISSIMILARITY VARIANCE (1 0)'
-    comp !cumd= (b+c)/(4*m).
-    comp done= 1.
    !else !if (!measure='MN') !then !let !lab= 'DISSIMILARITY MCNEMAR DIST (1 0)'
-    comp !cumd= b+c.
-    call setdiag(!cumd,1).
-    comp cumd0= !cumd=0.
-    do if any(cumd0).
-     print /title '>ERROR. The denominator of the formula is sometimes zero.'.
-     comp cumd0= rmax(cumd0&*(1:ncol(cumd0))(make(1,ncol(cumd0),1),:)).
-     loop i= 1 to nrow(cumd0).
-     end loop if cumd0(i).
-     print !idnam({i,cumd0(i)}) /title '>The problem is in this pair of vectors:' /format= a8 /space= 0.
-    else.
-     comp !cumd= abs(b-c)/sqrt(!cumd).
-     comp done= 1.
-     release cumd0.
-    end if.
    !else !if (!measure='TETRACH') !then !let !lab= 'SIMILARITY TETRACHORIC CORR (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp ad= sqrt(a&*d).
-     comp bc= sqrt(b&*c).
-     comp sign= (ad-bc)>=0.
-     comp !cumd= bc&*sign+ad&*(not sign).
-     comp !cumd= (2*sign-1)&*cos(3.1415926535898*!cumd/(ad+bc)).
-     comp done= 1.
-     comp lolim= -1.
-     release ad,bc,sign.
-    end if.
    !else !if (!measure='D') !then !let !lab= 'SIMILARITY ANDENBERG D (1 0)'
-    comp t1= ((a>=b)&*a+(a<b)&*b)+((c>=d)&*c+(c<d)&*d)+((a>=c)&*a+(a<c)&*c)+((b>=d)&*b+(b<d)&*d).
-    comp acbd= (a+c)>=(b+d).
-    comp abcd= (a+b)>=(c+d).
-    comp t2= (acbd&*(a+c)+(not acbd)&*(b+d))+(abcd&*(a+b)+(not abcd)&*(c+d)).
-    comp !cumd= (t1-t2)/(2*m).
-    comp done= 1.
-    comp uplim= .5.
-    release t1,t2,acbd,abcd.
    !else !if (!measure='LAMBDA') !then !let !lab= 'SIMILARITY GOODMAN-KRUSKAL LAMBDA (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp t1= ((a>=b)&*a+(a<b)&*b)+((c>=d)&*c+(c<d)&*d)+((a>=c)&*a+(a<c)&*c)+((b>=d)&*b+(b<d)&*d).
-     comp acbd= (a+c)>=(b+d).
-     comp abcd= (a+b)>=(c+d).
-     comp t2= (acbd&*(a+c)+(not acbd)&*(b+d))+(abcd&*(a+b)+(not abcd)&*(c+d)).
-     comp !cumd= (t1-t2)/(2*m-t2).
-     comp done= 1.
-     release t1,t2,acbd,abcd.
-    end if.
    !else !if (!measure='Q' !or !measure='Y' !or !measure='DIGBY') !then
     !if (!measure='Y') !then !let !lab= 'SIMILARITY YULE Y (1 0)' !let !sqrt= 'sqrt'
     !else !if (!measure='DIGBY') !then !let !lab= 'SIMILARITY DIGBY (1 0)' !let !power= '&**.75'
     !else !let !lab= 'SIMILARITY YULE Q (1 0)'
     !ifend !ifend
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp ad= !sqrt(a&*d)!power.
-     comp bc= !sqrt(b&*c)!power.
-     comp !cumd= (ad-bc)/(ad+bc).
-     comp done= 1.
-     comp lolim= -1.
-     release ad,bc.
-    end if.
    !else !if (!measure='GK1') !then !let !lab= 'SIMILARITY GOODMAN-KRUSKAL 1 (1 0)'
-    do if csum(sum=0)>1 or csum(sum=m)>1.
-     print /title '>ERROR. Among vectors to compute proximity between, there are more than one - zero'.
-     print /title '>or more than one - unit.' /space= 0.
-    else.
-     comp minad= (a<d)&*a+(a>=d)&*d.
-     comp bpc= b+c.
-     comp !cumd= 2*minad+bpc.
-     comp cumd0= !cumd=0.
-     comp !cumd= (2*minad-bpc+cumd0)/(!cumd+cumd0).
-     comp done= 1.
-     comp lolim= -1.
-     release minad,bpc,cumd0.
-    end if.
    !else !if (!measure='SIMPSON') !then !let !lab= 'SIMILARITY SIMPSON (1 0)'
-    do if any(sum=0).
-     print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-    else.
-     comp apb= a+b.
-     comp apc= a+c.
-     comp apbgeapc= apb>=apc.
-     comp !cumd= a/(apb&*(not apbgeapc)+apc&*apbgeapc).
-     comp done= 1.
-     release apb,apc,apbgeapc.
-    end if.
    !else !if (!measure='BRAUN') !then !let !lab= 'SIMILARITY BRAUN (1 0)'
-    do if csum(sum=0)>1.
-     print /title '>ERROR. Among vectors to compute proximity between, there are more than one - zero.'.
-    else.
-     comp apb= a+b.
-     comp apc= a+c.
-     comp apbgeapc= apb>=apc.
-     comp !cumd= apb&*apbgeapc+apc&*(not apbgeapc).
-     comp abac0= !cumd=0.
-     comp !cumd= (a+abac0)/(!cumd+abac0).
-     comp done= 1.
-     release apb,apc,apbgeapc,abac0.
-    end if.
    !else !if (!measure='FAI2' !or !measure='FAI1') !then !let !lab= 'SIMILARITY FAITH 2 (1 0)'
-    comp !cumd= (2*a+d)/(2*m).
     !if (!measure='FAI1') !then !let !lab= 'SIMILARITY FAITH 1 (1 0)'
-     comp !cumd= 2*!cumd-1.
-     comp lolim= -1.
     !ifend
-    comp done= 1.
    !else !if (!measure='BUB2' !or !measure='BUB1') !then !let !lab= 'SIMILARITY BARONI-URBANI-BUSER 2 (1 0)'
-    do if csum(sum=0)>1.
-     print /title '>ERROR. Among vectors to compute proximity between, there are more than one - zero.'.
-    else.
-     comp sqad= sqrt(a&*d).
-     comp !cumd= a+b+c+sqad.
-     comp abcad0= !cumd=0.
-     comp !cumd= (a+sqad+abcad0)/(!cumd+abcad0).
      !if (!measure='BUB1') !then !let !lab= 'SIMILARITY BARONI-URBANI-BUSER 1 (1 0)'
-      comp !cumd= 2*!cumd-1.
-      comp lolim= -1.
      !ifend
-     comp done= 1.
-     release sqad,abcad0.
-    end if.
    !else !if (!measure='QDIFF') !then !let !lab= 'DISSIMILARITY Q0 DIFFERENCE (1 0)'
-    comp !cumd= a&*d.
-    comp cumd0= !cumd=0.
-    do if any(cumd0).
-     print /title '>ERROR. The denominator of the formula is sometimes zero.'.
-     comp cumd0= rmax(cumd0&*(1:ncol(cumd0))(make(1,ncol(cumd0),1),:)).
-     loop i= 1 to nrow(cumd0).
-     end loop if cumd0(i).
-     print !idnam({i,cumd0(i)}) /title '>The problem is in this pair of vectors:' /format= a8 /space= 0.
-    else.   
-     comp !cumd= b&*c/!cumd.
-     comp done= 1.
-     release cumd0.
-    end if.
    !else !if (!measure='MOUNTF') !then !let !lab= 'SIMILARITY MOUNTFORD (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp b0= b.
-     call setdiag(b0,1).
-     comp b0= b0=0.
-     do if any(b0).
-      print /title '>ERROR. Counts B or C are sometimes zero.' /space= 0.
-      comp b0= rmax(b0&*(1:ncol(b0))(make(1,ncol(b0),1),:)).
-      loop i= 1 to nrow(b0).
-      end loop if b0(i).
-      print !idnam({i,b0(i)}) /title '>The problem is in this pair of vectors:' /format= a8 /space= 0.
       !if (!cumd<>'cumd') !then
-       print /title '>The problem occured not at computation but at rescaling (s/c ADJUST) of the measure.' /space= 0.
-       comp done= 0.
       !ifend
-     else. 
-      comp !cumd= (a&*b+a&*c+2*b&*c).
-      call setdiag(!cumd,2*sum).
-      comp !cumd= 2*a/!cumd.
-      comp done= 1.
-      release b0.
-     end if.
-    end if.
    !else !if (!measure='FCOS') !then !let !lab= 'SIMILARITY FAGER CORRECTED COSINE (1 0)'
-    do if any(sum=0).
-     print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-    else.
-     comp apb= a+b.
-     comp apc= a+c.
-     comp apbgeapc= apb>=apc.
-     comp !cumd= a/sqrt((a+b)&*(a+c))-1/(2*sqrt(apb&*apbgeapc+apc&*(not apbgeapc))).
-     comp !cumd= !cumd&*(!cumd>=0).
-     comp done= 1.
-     release apb,apc,apbgeapc.
-    end if.
    !else !if (!measure='MICHAEL') !then !let !lab= 'SIMILARITY MICHAEL (1 0)'
-    comp apd= a+d.
-    comp bpc= b+c.
-    comp !cumd= 4*(a&*d-b&*c)/(apd&*apd+bpc&*bpc).
-    comp done= 1.
-    comp lolim= -1.
-    release apd,bpc.
    !else !if (!measure='HD') !then !let !lab= 'SIMILARITY HAWKINS-DOTSON (1 0)'
-    do if csum(sum=0)>1 or csum(sum=m)>1.
-     print /title '>ERROR. Among vectors to compute proximity between, there are more than one - zero'.
-     print /title '>or more than one - unit.' /space= 0.
-    else.
-     comp abc= a+b+c.
-     comp cumd0= abc=0.
-     comp abc= (a+cumd0)/(abc+cumd0).
-     comp dbc= d+b+c.
-     comp cumd0= dbc=0.
-     comp dbc= (d+cumd0)/(dbc+cumd0).
-     comp !cumd= (abc+dbc)/2.
-     comp done= 1.
-     release abc,dbc,cumd0.
-    end if.
    !else !if (!measure='FORBES') !then !let !lab= 'SIMILARITY FORBES (1 0)'
-    do if any(sum=0).
-     print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-    else.
-     comp !cumd= m*a/((a+b)&*(a+c)).
-     comp done= 1.
-     comp uplim= m.
-    end if.
    !else !if (!measure='PMI') !then !let !lab= 'SIMILARITY POINT MUTUAL INFORMATION (1 0)'
-    comp cumd0= a=0.
-    do if any(sum=0).
-     print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-    else if any(cumd0).
-     print /title '>ERROR. Logarithm argument of the formula sometimes equals 0, because "a"=0.'.
-     comp cumd0= rmax(cumd0&*(1:ncol(cumd0))(make(1,ncol(cumd0),1),:)).
-     loop i= 1 to nrow(cumd0).
-     end loop if cumd0(i).
-     print !idnam({i,cumd0(i)}) /title '>The problem is in this pair of vectors:' /format= a8 /space= 0.
      !if (!cumd<>'cumd') !then
-      print /title '>The problem occured not at computation but at rescaling (s/c ADJUST) of the measure.' /space= 0.
-      comp done= 0.
      !ifend
-    else.
-     comp !cumd= ln(m*a/((a+b)&*(a+c))).
-     comp done= 1.
-     comp uplim= ln(m).
-     comp lolim= -10.
-     release cumd0.
-    end if.
    !else !if (!measure='ALROY') !then !let !lab= 'SIMILARITY ALROY (1 0)'
-    do if any(sum=0).
-     print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-    else.
-     comp !cumd= m-d.
-     comp !cumd= (!cumd+sqrt(!cumd))&*a.
-     comp !cumd= !cumd/(!cumd+1.5*b&*c).
-     comp done= 1.
-    end if.
    !else !if (!measure='DENNIS') !then !let !lab= 'SIMILARITY DENNIS (1 0)'
-    do if any(sum=0).
-     print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-    else.
-     comp !cumd= (a&*d-b&*c)/sqrt(m*(a+b)&*(a+c)).
-     comp done= 1.
-     comp uplim= (m-1)/sqrt(m).
-     comp lolim= -m/(2*sqrt(m)).
-    end if.
    !else !if (!measure='TARWID') !then !let !lab= 'SIMILARITY TARWID (1 0)'
-    do if any(sum=0).
-     print /title '>ERROR. Some vectors to compute proximity between are zero.'.
-    else.
-     comp !cumd= (a+b)&*(a+c).
-     comp !cumd= (m*a-!cumd)/(m*a+!cumd).
-     comp done= 1.
-     comp uplim= (m-1)/(m+1).
-     comp lolim= -1.
-    end if.
    !else !if (!measure='KAPPA') !then !let !lab= 'SIMILARITY COHEN KAPPA (1 0)'
-    do if csum(sum=0)>1 or csum(sum=m)>1.
-     print /title '>ERROR. Among vectors to compute proximity between, there are more than one - zero'.
-     print /title '>or more than one - unit.' /space= 0.
-    else.
-     comp !cumd= (a+b)&*(b+d)+(a+c)&*(c+d).
-     comp cumd0= !cumd=0.
-     comp !cumd= (2*(a&*d-b&*c)+cumd0)/(!cumd+cumd0).
-     comp done= 1.
-     comp lolim= -1.
-     release cumd0.
-    end if.
    !else !if (!measure='SPI') !then !let !lab= 'SIMILARITY SCOTT PI (1 0)'
-    do if csum(sum=0)>1 or csum(sum=m)>1.
-     print /title '>ERROR. Among vectors to compute proximity between, there are more than one - zero'.
-     print /title '>or more than one - unit.' /space= 0.
-    else.
-     comp bmc= b-c.
-     comp bpc= b+c.
-     comp !cumd= (2*a+bpc)&*(bpc+2*d).
-     comp cumd0= !cumd=0.
-     comp !cumd= (4*(a&*d-b&*c)-bmc&*bmc+cumd0)/(!cumd+cumd0).
-     comp done= 1.
-     comp lolim= -1.
-     release bmc,bpc,cumd0.
-    end if.
    !else !if (!measure='LOEV') !then !let !lab= 'SIMILARITY LOEVINGER (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp abbd= (a+b)&*(b+d).
-     comp accd= (a+c)&*(c+d).
-     comp !cumd= (abbd<accd)&*abbd+(abbd>=accd)&*accd.
-     comp !cumd= (a&*d-b&*c)/!cumd.
-     comp done= 1.
-     comp lolim= -(m-1).
-     release abbd,accd.
-    end if.
    !else !if (!measure='COLE') !then !let !lab= 'SIMILARITY COLE (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp abac= (a+b)&*(a+c).
-     comp bdcd= (b+d)&*(c+d).
-     comp !cumd= (abac<bdcd)&*abac+(abac>=bdcd)&*bdcd.
-     comp !cumd= (a&*d-b&*c)/!cumd.
-     comp done= 1.
-     comp uplim= m-1.
-     comp lolim= -1.
-     release abac,bdcd.
-    end if.
    !else !if (!measure='MAXWELL') !then !let !lab= 'SIMILARITY MAXWELL-PILLINER (1 0)'
-    do if (csum(sum=0)>1 or csum(sum=m)>1) or any(sum=0) and any(sum=m).
-     print /title '>ERROR. Among vectors to compute proximity between, there are more than one - constant.'.
-    else.
-     comp !cumd= (a+b)&*(c+d)+(a+c)&*(b+d).
-     comp cumd0= !cumd=0.
-     comp !cumd= (2*(a&*d-b&*c)+cumd0)/(!cumd+cumd0).
-     comp done= 1.
-     comp lolim= -1.
-     release cumd0.
-    end if.
    !else !if (!measure='FLEISS') !then !let !lab= 'SIMILARITY FLEISS (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp apb= a+b.
-     comp cpd= c+d.
-     comp !cumd= (a&*d-b&*c)&*(apb&*(b+d)+(a+c)&*cpd)/(2*apb&*(a+c)&*(b+d)&*cpd).
-     comp done= 1.
-     comp lolim= -((m-1)/2+1/(m-1)).
-     release apb,cpd.
-    end if.
    !else !if (!measure='EYRAUD') !then !let !lab= 'SIMILARITY EYRAUD (1 0)'
-    do if any(sum=0) or any(sum=m).
-     print /title '>ERROR. Some vectors to compute proximity between are constants.'.
-    else.
-     comp !cumd= (a+b)&*(a+c).
-     comp !cumd= m**2*(m*a-!cumd)/(!cumd&*(b+d)&*(c+d)).
-     comp done= 1.
-     comp uplim= m**2/(m-1).
-     comp lolim= -(m**2)/(m-1).
-    end if.
    !else !if (!measure='GILBERT') !then !let !lab= 'SIMILARITY GILBERT (1 0)'
-    do if csum(sum=0)>1 or csum(sum=m)>1.
-     print /title '>ERROR. Among vectors to compute proximity between, there are more than one - zero'.
-     print /title '>or more than one - unit.' /space= 0.
-    else.
-     comp ea= (a+b)&*(a+c)/m.
-     comp !cumd= a+b+c-ea.
-     comp cumd0= !cumd=0.
-     comp !cumd= (a-ea+cumd0)/(!cumd+cumd0).
-     comp done= 1.
-     comp lolim= -1.
-     release ea,cumd0.
-    end if. 
    !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend
    !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend
    !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend
    !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend
    !if (!cumd<>'cumd') !then
-    end if.
    !ifend
-   do if done.
-    do if ncol(cumd)=2.
-     print {a(2,1),b(2,1);c(2,1),d(2,1)} /title=
      !if (!cumd='cumd') !then 'Table of observed counts {a,b;c,d} giving Sobs (or Dobs):'
      !else !if (!cumd='bcumd') !then 'Table of expected counts {a,b;c,d} giving Sbenchmark:'
      !else !if (!cumd='pcumd') !then 'Table of extreme counts {a,b;c,d} giving Spole:'
      !ifend !ifend !ifend .
-    end if.
-   end if.
-   release a,b,c,d.
   !doend
  !ifend
-end if.
-do if done.
  !if (!index(!measure,'_')=0) !then
   !if (!adjust='INDBOUND' !or !adjust='INDUPPER') !then !let !lab= !conc(!lab,' [',!adjust,']')
-   comp cumd= cumd-bcumd.
-   comp cumd= cumd&*(abs(cumd)>=1E-14).
    !if (!adjust='INDBOUND') !then
-    comp bcumd= abs(uplim*(cumd>=0)+lolim*(cumd<0)-bcumd).
    !else
-    comp bcumd= abs(uplim-bcumd).
    !ifend
-   comp cumd= cumd/(bcumd+(bcumd=0)).
   !else !if (!adjust='MARGPOLE' !or !adjust='INDMARGPOLE' !or !adjust='INDMARGMAX') !then !let !lab= !conc(!lab,' [',!adjust,']')
-   comp cumd= cumd&*(abs(cumd)>=1E-14).
-   comp pcumd= abs(pcumd-bcumd).
-   comp cumd= cumd/(pcumd+(pcumd=0)).
   !ifend !ifend
   !if (!measure='K1' !or !measure='SS3' !or !measure='MOUNTF') !then
-   call setdiag(cumd,1)
   !ifend
-  comp cumd= (cumd+t(cumd))/2.
   !if (!abs='YES') !then
-   comp cumd= abs(cumd).
   !ifend
   !if (!reverse<>'NONE' !and !reverse<>!null) !then
    !if (!substr(!lab,1,3)='DIS') !then !let !lab= !conc('SIMILARITY [',!reverse,']',!tail(!lab))
    !else !let !lab= !conc('DISSIMILARITY [',!reverse,']',!tail(!lab))
    !ifend
    !if (!reverse='ONEMINUS') !then
-    comp cumd= 1-cumd.
    !else !if (!reverse='LAWCOS') !then
-    do if !simil.
-     comp cumd= 1-cumd.
-     comp cumdneg= cumd<0.
-     do if any(cumdneg).
-      print /title '>WARNING. REVERSE=LAWCOS revealed negative values under sq. root of some elements.'.
-      print /title '>These elements are replaced with -999.' /space= 0.
-      comp cumd= cumd&*(not cumdneg).
-     end if.
-     comp cumd= sqrt(cumd)-999*(cumdneg).
-    else.
-     comp cumd= 1-cumd&*cumd.
-    end if.
    !else !if (!reverse='RECIP') !then
-    do if !simil.
-     comp cumd0= cumd=0.
-     do if any(cumd0).
-      print /title '>WARNING. REVERSE=RECIP revealed zero values in denominator of some elements.'.
-      print /title '>These elements are replaced with -999.' /space= 0.
-      comp cumd= cumd+cumd0.
-     end if.
-     comp cumd= 1/cumd-1-999*(cumd0).
-    else.
-     comp cumd= 1/(cumd+1).
-    end if.
    !else
-    do if !simil.
-     call setdiag(cumd,0).
-     comp cumd= -cumd.
-     comp cumd= cumd-mmin(cumd).
-     call setdiag(cumd,0).
-    else.
-     comp cumd= -cumd.
-     comp min= mmin(cumd).
-     comp cumd= cumd-min+(min=0).
-    end if.
    !ifend !ifend !ifend
   !ifend
   !if (!measure='K1' !or !measure='SS3' !or !measure='MOUNTF') !then
-   call setdiag(cumd,999).
-   print /title '>NOTE. For measures K1, SS3, MOUNTF, 999 is put on the diagonal: diag. values are incomputable.'.
    !if (!reverse<>'NONE' !and !reverse<>!null) !then
-    call setdiag(cumd,-999).
-    print /title '>Since REVERSE<>NONE, 999 is turned into -999.' /space= 0.
    !ifend
   !ifend
  !ifend
  !if (!view='VARIABLE') !then
-  comp rowtype= make(nrow(cumd),1,'PROX').
-  comp cn= {'rowtype_','varname_',names}.
-  save {rowtype,t(names),cumd} /out= * /names= cn /strings= rowtype_ varname_.
  !else
-  save {id,case,cumd} /out= * /vari= !iddd caseno_ var1 to var50000 /string= !iddd.
  !ifend
-else.
- print /title '>!KO_PROXBIN is executed incorrectly.' /space= 0.
- save 0 /out= *.
-end if.
-end matrix.
-set results none errors none.
 !if (!view<>'VARIABLE') !then
- matrix.
- get m /names= names.
- do if ncol(m)>1.
-  comp rowtype= make(nrow(m),1,'PROX').
-  comp cn= {'rowtype_',!quote(!iddd),'caseno_','varname_',names(3:ncol(names))}.
-  save {rowtype,m(:,1:2),t(names(3:ncol(names))),m(:,3:ncol(m))} /out= * /names= cn /strings= rowtype_ !iddd varname_.
- end if.
- end matrix.
 !ifend
-format all (f8.3).
-!fcaseno.
-set results list errors list.
-var lev all (sca) rowtype_ to varname_ (nom).
-val lab rowtype_ 'PROX' !quote(!lab).
!ifend !ifend !ifend
!enddefine.

*/*!KO_TETRACH*/***************************************************************************.
define !KO_tetrach(vars= !charend('/') /missing= !charend('/'))
!if (!missing='LISTWISE') !then !let !miss= 'omit' !else !let !miss= '-999' !ifend
matrix.
get dat /vari= !vars /names= cn /miss= !miss.
comp valid= dat<>-999.
comp dat= dat&*valid.
do if not all((dat=0)+(dat=1)).
-print /title '>ERROR. The data contain non-binary values.'.
else.
-comp n= sscp(valid).
-comp a= sscp(dat).
-do if any(t(valid)*dat=0) or any(t(valid)*dat=n).
- print /title '>ERROR. On deletion missing data, some variables are constants.'.
-else.
- comp b= t(valid)*dat-a.
- comp d= n-a-b-t(b).
- comp a= sqrt(a&*d).
- comp b= sqrt(b&*t(b)).
- comp sign= (a-b)>=0.
- comp lesser= b&*sign+a&*(not sign).
- comp tet= (2*sign-1)&*cos(3.14159265*lesser/(a+b)).
- comp rowtype= make(ncol(tet),1,'CORR').
- comp cn_= {'rowtype_','varname_',cn}.
- save {rowtype,t(cn),tet} /outfile= * /names= cn_ /strings= rowtype_ varname_.
-end if.
end if.
end matrix.
val lab rowtype_ 'CORR' 'SIMILARITY TETRACHCOR'.
!enddefine.

*/*!KO_BISER*/***************************************************************************.
define !KO_biser(scale= !charend('/') /binar= !charend('/') /missing= !charend('/') /alpha= !charend('/'))
!if (!missing='LISTWISE') !then
-count #nmiss= !scale !binar (missing).
-select if #nmiss=0.
!ifend
set errors none.
dataset close *.
set errors list.
matrix.
get sca /vari= !scale /names= scanam /miss= -999.
get bin /vari= !binar /names= binnam /miss= -999.
comp validsca= sca<>-999.
comp validbin= bin<>-999.
comp n= t(validsca)*validbin.
comp sca= sca&*validsca.
comp bin1= bin&*validbin.
comp bin0= (not bin)&*validbin.
do if not all((bin1=0)+(bin1=1)).
-print /title '>ERROR. Data BINAR contain non-binary values.'.
else.
-do if not all(t(validsca)*bin1) or not all(t(validsca)*bin0).
- print /title '>ERROR. On deletion missing data, some of BINAR are constants.'.
-else.
- comp m1= t(sca)*bin1/(t(validsca)*bin1).
- comp m0= t(sca)*bin0/(t(validsca)*bin0).
- comp sum= t(sca)*validbin.
- comp ss= t(sca&**2)*validbin.
- comp mean= sum/n.
- comp sd= sqrt((ss-2*mean&*sum+n&*mean&**2)/n).
- comp q= t(validsca)*bin0/n.
- comp pq= (1-q)&*q.
- save ((m1-m0)/sd&*pq) /outfile= 'temp_KO_biser_1.sav'.
- save pq /outfile= 'temp_KO_biser_2.sav'.
- save n /outfile= 'temp_KO_biser_3.sav'.
- save scanam /outfile= 'temp_KO_biser_4.sav'.
- save binnam /outfile= 'temp_KO_biser_5.sav'.
- save q /outfile= *.
-end if.
end if.
end matrix.
do rep q= all.
-comp q= probit(q).
end rep.
matrix.
get h.
get bis /file= 'temp_KO_biser_1.sav'.
get pq /file= 'temp_KO_biser_2.sav'.
get n /file= 'temp_KO_biser_3.sav'.
get scanam /file= 'temp_KO_biser_4.sav'.
get binnam /file= 'temp_KO_biser_5.sav'.
comp h= exp(-.5*h&**2)/2.506628275.
comp bis= bis/h.
comp sig= bis&*sqrt(n)/(sqrt(pq)/h-bis&**2).
comp sig= 2*(1-cdfnorm(abs(sig))).
do if any(abs(bis)>1).
-print /title '>WARNING. Some coefficients are higher then 1 by abs. value.'.
end if.
!if (!alpha<>!null) !then
-comp bis= bis&*(sig<!alpha).
-print /title !quote(!concat('Nonsignificant at alpha level ',!alpha,' (2-tailed) coef-s are turned into 0.')).
!ifend
print bis /cnames= binnam /rnames= scanam /format= f8.3 /title= 'Biserial correlation coefficient:'.
!if (!alpha=!null) !then
-print sig /cnames= binnam /rnames= scanam /format= f8.3 /title= 'Its approximate 2-tailed significance:'.
!ifend
!if (!missing='LISTWISE') !then
-print n(1,1) /title= 'Valid N:'.
!else
-print n /cnames= binnam /rnames= scanam /title= 'Valid N:'.
!ifend
comp binnam= {'scalevar',binnam}.
save {t(scanam),bis} /outfile= * /names= binnam /string= scalevar.
end matrix.
erase file 'temp_KO_biser_1.sav'.
erase file 'temp_KO_biser_2.sav'.
erase file 'temp_KO_biser_3.sav'.
erase file 'temp_KO_biser_4.sav'.
erase file 'temp_KO_biser_5.sav'.
!enddefine.

*/*!KO_ACORRD*/***************************************************************************.
define !KO_acorrd(vars= !charend('/') /negat= !charend('/') /missing= !charend('/'))
set mxloops 10000 results none errors none.
count miss####= !vars (missing).
comp case####= $casenum.
select if not(case####=1 and miss####>0).
!if (!missing='MEAN' !or !missing='LINT') !then
 !if (!missing='MEAN') !then !let !span=1 !ifend
-rmv !vars= !missing(!vars !span).
!ifend
dataset close *.
set results list errors list.
matrix.
!if (!missing='LAG') !then !let !miss= '-999' !else !let !miss= 'omit' !ifend
get dat /vari= !vars /names= names /miss= !miss.
comp p= ncol(dat).
comp cumd= make(ncol(dat),ncol(dat),0).
comp d= dat(1,:)(make(1,p,1),:). 
comp d_= d-t(d).
loop i= 2 to nrow(dat).
 !if (!missing='LAG') !then
- comp dat(i,:)= dat(i,:)&*(dat(i,:)<>-999)+dat(i-1,:)&*(dat(i,:)=-999).
 !ifend
-comp d= dat(i,:)(make(1,p,1),:). 
-comp d= d-t(d).
-comp cumd= cumd+d&*d_.
-comp d_= d.
end loop.
print {msum(cumd<0),msum(cumd=0)-ncol(dat),msum(cumd>0)} /title 'Number of negative, zero, and positive distances in the matrix:'.
call setdiag(cumd,mmax(cumd)+1).
comp min= mmin(cumd).
call setdiag(cumd,mmin(cumd)-1).
print {min,mmax(cumd)} /title 'Minimal and maximal distances in the matrix:'.
call setdiag(cumd,0).
do if min<0.
 !if (!negat='ABS' !or !negat=!null) !then
- comp cumd= abs(cumd).
- print /title 'Sign of negative distances was then discarded.'.
 !ifend
 !if (!negat='ZERO') !then
- comp cumd= cumd&*(cumd>=0).
- print /title 'Negative distances were then replaced by zero.'.
 !ifend
end if.
comp rowtype= make(nrow(cumd),1,'PROX').
comp names_= {'rowtype_','varname_',names}.
save {rowtype,t(names),cumd} /outfile= * /names= names_ /strings= rowtype_ varname_.
end matrix.
val lab rowtype_ 'PROX' 'DISSIMILARITY AUTOCORR DISTANCE'.
!enddefine.

*/*!KO_RESCR*/***************************************************************************.
define !KO_rescr(vars= !charend('/') /rescale= !charend('/') /eigen= !charend('/') /save= !charend('/') /id= !charend('/'))
set mxloops 10000.
matrix.
!if (!eigen<>'NO' !and !save<>!null !and !id<>!null) !then
-get dat /vari= !id !vars /names= cn /miss= omit.
-comp id= dat(:,1).
-comp dat= dat(:,2:ncol(dat)).
!else
-get dat /vari= !vars /names= cn /miss= omit.
!ifend
comp n= nrow(dat).
comp dat= dat-(csum(dat)/n)(make(1,n,1),:).
comp dat= dat/sqrt(cssq(dat)/(n-1))(make(1,n,1),:).
comp r= sscp(dat)/(n-1).
do if det(r)=0.
-print /title '>WARNING. Complite linear dep-cies found in data. Matrix of usual r is singular.'.
end if.
comp sdat= dat.
loop i= 1 to ncol(dat).
-comp sdat(grade(dat(:,i)),i)= dat(:,i).
end loop.
comp maxr= sscp(sdat)/(n-1).
comp minr= (t(sdat)*sdat(n:1:-1,:))/(n-1).
!if (!rescale='RANGE') !then !let !meth= 'RANGE.'
-comp newr= 2*(r-maxr)/(maxr-minr)+1.
!else !let !meth= 'POLE.'
-comp newr= r/(maxr&*(r>=0)-minr&*(r<0)).
!ifend
comp newr= (newr+t(newr))/2.
print /title !quote(!conc('>Usual r were rescaled by method ',!meth)).
print (msum(abs(newr-r))/(ncol(dat)**2-ncol(dat))) /title '>Mean abs. difference of rescaled r from usual r:' /format= f8.5.
release sdat,minr,maxr.
!if (!eigen<>'NO') !then
-comp gram= 1.
-comp dr= newr-r.
-loop i= 9 to 1 by -1 if eval(newr)(ncol(dat))<0.
- comp newr= r+i/10*dr.
-end loop.
-do if i=9.
- print /title '>Matrix of rescaled r appeared positive (semi)definite.'.
-else.
- print /title '>Matrix of rescaled r appeared negative (semi)definite,'.
- print /title ' therefore their difference from usual r were lessened.' /space= 0. 
- do if eval(newr)(ncol(dat))<0.
-  print /title '>WARNING. However the matrix remained negative (semi)definite.' /space= 0.
-  comp gram= 0.
- else.
-  print /title '>The matrix became positive (semi)definite.' /space= 0.
- end if.
- print (msum(abs(newr-r))/(ncol(dat)**2-ncol(dat))) /title '>Mean abs. difference of rescaled r from usual r:' /format= f8.5.
-end if.
 !if (!save<>!null) !then
- do if gram and det(newr) and det(r).
-  print /title '>Variables fitted for matrix of rescaled r were saved'.
-  print /title ' standardized to where SAVE specifies.' /space= 0.
-  call eigen(newr,eivec,eival).
-  call eigen(r,eivec_,eival_).
-  comp cmps= dat*inv(t(eivec_)).
-  comp cmps= cmps&*kroneker(t(sqrt(eival/eival_)),make(n,1,1)).
-  comp dat= cmps*t(eivec).
-  save {!if (!id<>!null) !then id, !ifend dat} /outfile= !save /names= cn.
- else.
-  print /title '>WARNING. SAVE not executed because matrix of usual r or matrix of rescaled r'.
-  print /title '          is not positive definite.' /space= 0.
- end if.
 !ifend
!ifend
print /title '>Matrix of rescaled r saved into new data window.'.
!if (!eigen<>'NO' !and !save<>!null !and !id<>!null) !then
-comp cn= cn(2:ncol(cn)).
!ifend
comp rowtype= {'N';make(ncol(dat),1,'CORR')}.
comp cn_= {'rowtype_','varname_',cn}.
save {rowtype,t({' ',cn}),{make(1,ncol(dat),n);newr}} /outfile= * /names= cn_ /strings= rowtype_ varname_.
end matrix.
!enddefine.
